VERSION 5.00
Begin VB.Form Burn 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Burn editor"
   ClientHeight    =   4245
   ClientLeft      =   180
   ClientTop       =   450
   ClientWidth     =   9795
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Burn.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   283
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   653
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   Begin Project.DropList File 
      Height          =   225
      Left            =   75
      TabIndex        =   0
      Top             =   75
      Width           =   1530
      _ExtentX        =   2699
      _ExtentY        =   397
      Caption         =   ""
      Text            =   "Default"
      Style           =   1
      ToolTip         =   "Burn preset"
   End
   Begin Project.Button CalcNozzle 
      Height          =   240
      Left            =   1635
      TabIndex        =   1
      Top             =   60
      Width           =   255
      _ExtentX        =   1588
      _ExtentY        =   450
      Caption         =   ""
      Image           =   "Burn.frx":000C
      ToolTip         =   "Calculate the optimal nozzle throat and exit parameters"
   End
   Begin Project.Button CalcCurve 
      Height          =   240
      Left            =   1920
      TabIndex        =   2
      Top             =   60
      Width           =   255
      _ExtentX        =   1588
      _ExtentY        =   450
      Caption         =   ""
      Image           =   "Burn.frx":0526
      ToolTip         =   "Generate a custom engine or a generic thrust curve"
   End
   Begin Project.Edit Mol 
      Height          =   225
      Left            =   2325
      TabIndex        =   9
      Top             =   75
      Width           =   1575
      _ExtentX        =   2646
      _ExtentY        =   397
      Caption         =   "Mol"
      Text            =   "31.478g/mol"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Effective molar mass [g/mol] [lb/mol]"
   End
   Begin Project.Edit Chamber 
      Height          =   225
      Left            =   4050
      TabIndex        =   16
      Top             =   75
      Width           =   1350
      _ExtentX        =   2381
      _ExtentY        =   397
      Caption         =   "Chamber"
      Text            =   "110%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Motor chamber length [m], [in], [ft] or percent ratio of the propellant length [%] or chamber volume [m], [in], [ft]"
   End
   Begin Project.DropList Class 
      Height          =   225
      Left            =   5550
      TabIndex        =   22
      Top             =   75
      Width           =   1800
      _ExtentX        =   3043
      _ExtentY        =   397
      Caption         =   "Type"
      Text            =   "Core Burner"
      List            =   "Core Burner|End Burner|Star Burner"
      ToolTip         =   "Geometry of the propellant core"
      Locked          =   -1  'True
   End
   Begin Project.DropList Propellant 
      Height          =   225
      Left            =   75
      TabIndex        =   3
      Top             =   375
      Width           =   2100
      _ExtentX        =   3440
      _ExtentY        =   397
      Caption         =   "Propellant"
      Text            =   "APCP"
      ToolTip         =   "Type of solid propellant"
      Locked          =   -1  'True
   End
   Begin Project.Edit Kmix 
      Height          =   225
      Left            =   2325
      TabIndex        =   10
      Top             =   375
      Width           =   945
      _ExtentX        =   1535
      _ExtentY        =   397
      Caption         =   "K"
      Text            =   "1.172"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Ratio of specific heats of the mixture"
   End
   Begin Project.Edit K2ph 
      Height          =   225
      Left            =   3300
      TabIndex        =   11
      Top             =   375
      Width           =   600
      _ExtentX        =   1058
      _ExtentY        =   397
      Caption         =   ""
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Ratio of specific heats of the 2 phase flow (Optional)"
   End
   Begin Project.Edit Length 
      Height          =   225
      Left            =   4050
      TabIndex        =   17
      Top             =   375
      Width           =   1350
      _ExtentX        =   2381
      _ExtentY        =   397
      Caption         =   "Length"
      Text            =   "100mm"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   $"Burn.frx":0A40
   End
   Begin Project.Edit NSeg 
      Height          =   225
      Left            =   5550
      TabIndex        =   23
      Top             =   375
      Width           =   225
      _ExtentX        =   397
      _ExtentY        =   397
      Caption         =   ""
      Text            =   "1"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Number of segments in which the propellant is divided"
   End
   Begin Project.DropList Exposed 
      Height          =   225
      Left            =   5850
      TabIndex        =   24
      Top             =   375
      Width           =   1500
      _ExtentX        =   2646
      _ExtentY        =   397
      Caption         =   "Exposed"
      Text            =   "Nozzle"
      List            =   "None|Nozzle|Both"
      ToolTip         =   "Ends of the propellant exposed to burning"
      Locked          =   -1  'True
   End
   Begin Project.Edit BurnRate 
      Height          =   225
      Left            =   75
      TabIndex        =   4
      Top             =   675
      Width           =   1470
      _ExtentX        =   2593
      _ExtentY        =   397
      Caption         =   "Burn rate"
      Text            =   "2mm/s"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Propellant burn rate at standard amtosphere pressure [m/s], [in/s], [ft/s] or burn rate curve"
   End
   Begin Project.DropList BurnExp 
      Height          =   225
      Left            =   1575
      TabIndex        =   5
      Top             =   675
      Width           =   600
      _ExtentX        =   1588
      _ExtentY        =   397
      Caption         =   ""
      Text            =   "0.4"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Exponential parameter of the propellant burn rate (Optional)"
   End
   Begin Project.Edit Density 
      Height          =   225
      Left            =   2325
      TabIndex        =   12
      Top             =   675
      Width           =   1575
      _ExtentX        =   2646
      _ExtentY        =   397
      Caption         =   "Density"
      Text            =   "1.900g/cm"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Propellant density [g/cm], [lb/ft]"
   End
   Begin Project.Edit Diameter 
      Height          =   225
      Left            =   4050
      TabIndex        =   18
      Top             =   675
      Width           =   1350
      _ExtentX        =   2381
      _ExtentY        =   397
      Caption         =   "Diameter"
      Text            =   "50%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   $"Burn.frx":0AE1
   End
   Begin Project.Edit CoreLength 
      Height          =   225
      Left            =   5550
      TabIndex        =   25
      Top             =   675
      Width           =   1800
      _ExtentX        =   3175
      _ExtentY        =   397
      Caption         =   "Core length"
      Text            =   "100%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Propellant core length [m], [in], [ft] or percent ratio of the propellant length [%]"
   End
   Begin Project.DropList Burst 
      Height          =   225
      Left            =   75
      TabIndex        =   6
      Top             =   975
      Width           =   2100
      _ExtentX        =   3704
      _ExtentY        =   397
      Caption         =   "Burst pressure"
      Text            =   "60atm"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Maximum pressure of the motor chamber [atm], [bar] or maximum stress of the material [Pa], [psi] (Default=Unlimited)"
   End
   Begin Project.Edit Temp 
      Height          =   225
      Left            =   2325
      TabIndex        =   13
      Top             =   975
      Width           =   1575
      _ExtentX        =   2646
      _ExtentY        =   397
      Caption         =   "Temperature"
      Text            =   "3635K"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Combustion chamber temperature [K], [C], [R], [F]"
   End
   Begin Project.Edit NozzleThroat 
      Height          =   225
      Left            =   4050
      TabIndex        =   19
      Top             =   975
      Width           =   1350
      _ExtentX        =   2381
      _ExtentY        =   397
      Caption         =   "Throat"
      Text            =   "125:1"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Nozzle throat diameter [m], [in], [ft] or throat area [m], [in], [ft] or burning area to throat area ratio"
   End
   Begin Project.Edit CoreDiameter 
      Height          =   225
      Left            =   5550
      TabIndex        =   26
      Top             =   975
      Width           =   1800
      _ExtentX        =   3175
      _ExtentY        =   397
      Caption         =   "Core diameter"
      Text            =   "20%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Propellant core diameter [m], [in], [ft] or percent ratio of the propellant diameter [%]"
   End
   Begin Project.Edit Pressure 
      Height          =   225
      Left            =   75
      TabIndex        =   7
      Top             =   1275
      Width           =   2100
      _ExtentX        =   3704
      _ExtentY        =   397
      Caption         =   "External pressure"
      Text            =   "1atm"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Pressure outside the motor chamber [atm], [Pa], [bar], [psi]"
   End
   Begin Project.Edit Efficiency 
      Height          =   225
      Left            =   2325
      TabIndex        =   14
      Top             =   1275
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   397
      Caption         =   "Efficiency"
      Text            =   "85%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Nozzle efficiency ratio [%]"
   End
   Begin Project.Edit NozzleExit 
      Height          =   225
      Left            =   4050
      TabIndex        =   20
      Top             =   1275
      Width           =   1350
      _ExtentX        =   2381
      _ExtentY        =   397
      Caption         =   "Exit"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Nozzle exit diameter [m], [in], [ft] or exit area [m], [in], [ft] or throat to exit area expansion ratio (Default=Ideal ratio)"
   End
   Begin Project.Edit NFin 
      Height          =   225
      Left            =   5550
      TabIndex        =   27
      Top             =   1275
      Width           =   225
      _ExtentX        =   397
      _ExtentY        =   397
      Caption         =   ""
      Text            =   "5"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Number of fins in the propellant"
   End
   Begin Project.Edit FinDepth 
      Height          =   225
      Left            =   5850
      TabIndex        =   28
      Top             =   1275
      Width           =   1500
      _ExtentX        =   2646
      _ExtentY        =   397
      Caption         =   "Fin depth"
      Text            =   "50%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Propellant fin depth [m], [in], [ft] or percent ratio of the propellant radius [%]"
   End
   Begin Project.Edit EndPressure 
      Height          =   225
      Left            =   75
      TabIndex        =   8
      Top             =   1575
      Width           =   2100
      _ExtentX        =   3704
      _ExtentY        =   397
      Caption         =   "Burnout pressure"
      Text            =   "0.1atm"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Pressure at the end of thrust [atm], [Pa], [bar], [psi]"
   End
   Begin Project.Edit DryMass 
      Height          =   225
      Left            =   2325
      TabIndex        =   15
      Top             =   1575
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   397
      Caption         =   "Dry mass"
      Text            =   "20%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Engine dry mass [kg], [lb], [t] or percent ratio [%] or motor chamber density [g/cm], [lb/ft]"
   End
   Begin Project.Edit Thickness 
      Height          =   225
      Left            =   4050
      TabIndex        =   21
      Top             =   1575
      Width           =   1350
      _ExtentX        =   2381
      _ExtentY        =   397
      Caption         =   "Thickness"
      Text            =   "2%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Motor chamber thickness [m], [in], [ft] or percent ratio of the propellant diameter [%]"
   End
   Begin Project.Edit FinWidth 
      Height          =   225
      Left            =   5550
      TabIndex        =   29
      Top             =   1575
      Width           =   1500
      _ExtentX        =   2646
      _ExtentY        =   397
      Caption         =   "Fin width"
      Text            =   "10%"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Propellant fin width [m], [in], [ft] or percent ratio of the propellant radius [%]"
   End
   Begin Project.Button ShowLog 
      Height          =   225
      Left            =   7125
      TabIndex        =   35
      Top             =   1575
      Width           =   225
      _ExtentX        =   397
      _ExtentY        =   397
      State           =   -1  'True
      Caption         =   "3"
      Style           =   3
      ToolTip         =   "Show engine specifications"
      ForeColor       =   0
   End
   Begin VB.PictureBox Pic 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   2250
      Left            =   75
      ScaleHeight     =   150
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   30
      Top             =   1950
      Width           =   4800
      Begin VB.Image iWarning 
         Height          =   240
         Left            =   75
         Picture         =   "Burn.frx":0B87
         Top             =   75
         Visible         =   0   'False
         Width           =   240
      End
   End
   Begin VB.PictureBox PicH 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      FillStyle       =   0  'Solid
      Height          =   1275
      Left            =   5025
      ScaleHeight     =   85
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   85
      TabIndex        =   31
      TabStop         =   0   'False
      Tag             =   "Propellant cross section"
      Top             =   2025
      Width           =   1275
   End
   Begin VB.PictureBox PicV 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      FillStyle       =   0  'Solid
      Height          =   1275
      Left            =   6375
      ScaleHeight     =   85
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   60
      TabIndex        =   32
      TabStop         =   0   'False
      Tag             =   "Propellant longitudinal section"
      Top             =   2025
      Width           =   900
   End
   Begin VB.PictureBox PicD 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   870
      Left            =   5025
      ScaleHeight     =   58
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   155
      TabIndex        =   33
      TabStop         =   0   'False
      Top             =   3330
      Width           =   2325
   End
   Begin VB.TextBox Txt 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000012&
      Height          =   4200
      HideSelection   =   0   'False
      Left            =   7500
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   34
      Top             =   15
      Width           =   2250
   End
   Begin VB.Label Sep 
      BorderStyle     =   1  'Fixed Single
      Height          =   45
      Left            =   75
      TabIndex        =   36
      Top             =   1875
      Width           =   7275
   End
   Begin VB.Menu mnMenu 
      Caption         =   "Preset"
      Visible         =   0   'False
      Begin VB.Menu mnLoadPreset 
         Caption         =   "Load preset "
      End
      Begin VB.Menu mnSavePreset 
         Caption         =   "Save preset "
      End
      Begin VB.Menu mnDeletePreset 
         Caption         =   "Delete preset"
      End
      Begin VB.Menu mnSP0 
         Caption         =   "-"
      End
      Begin VB.Menu mnOutputFormat 
         Caption         =   "Output format"
         Begin VB.Menu mnCalcEngine 
            Caption         =   "Custom engine"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnCalcCurve 
            Caption         =   "Thrust curve"
         End
      End
      Begin VB.Menu mnGraphQuality 
         Caption         =   "Graph quality"
         Begin VB.Menu mnGraphLow 
            Caption         =   "Low"
         End
         Begin VB.Menu mnGraphMed 
            Caption         =   "Medium"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnGraphHigh 
            Caption         =   "High"
         End
      End
      Begin VB.Menu mnSP1 
         Caption         =   "-"
         Visible         =   0   'False
      End
      Begin VB.Menu mnPreset 
         Caption         =   "Default"
         Index           =   0
         Visible         =   0   'False
      End
   End
   Begin VB.Menu mnOptions 
      Caption         =   "Options"
      Visible         =   0   'False
      Begin VB.Menu mnData 
         Caption         =   "Thrust"
         Checked         =   -1  'True
         Index           =   0
      End
      Begin VB.Menu mnData 
         Caption         =   "Pressure"
         Index           =   1
      End
      Begin VB.Menu mnData 
         Caption         =   "Burn rate"
         Index           =   2
      End
      Begin VB.Menu mnData 
         Caption         =   "Expansion ratio"
         Index           =   3
      End
      Begin VB.Menu mnSPG1 
         Caption         =   "-"
      End
      Begin VB.Menu mnBurnGraph 
         Caption         =   "Burn graph"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnThroatGraph 
         Caption         =   "Nozzle throat"
      End
      Begin VB.Menu mnExitGraph 
         Caption         =   "Nozzle exit"
      End
      Begin VB.Menu mnSO1 
         Caption         =   "-"
      End
      Begin VB.Menu mnBurnPreview 
         Caption         =   "Burn preview"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnSO2 
         Caption         =   "-"
      End
      Begin VB.Menu mnCopyImage 
         Caption         =   "Copy image"
      End
      Begin VB.Menu mnCopyData 
         Caption         =   "Copy data"
      End
      Begin VB.Menu mnSaveData 
         Caption         =   "Save data "
      End
   End
   Begin VB.Menu mnStress 
      Caption         =   "Stress"
      Visible         =   0   'False
      Begin VB.Menu mnBurst 
         Caption         =   ""
         Index           =   0
      End
   End
End
Attribute VB_Name = "Burn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim IsAdjust As Boolean, NoResize As Boolean, Max As BurnPointB, _
    Msg As String, Gc As String, Ei As Long, Md As Long, Ng As Long, _
    Mt As Double, Mc As Double, Mg As Double, Vg As Double, Lg As Double, De As Double, _
    Lc As Double, Dc As Double, Ld As Double, L0 As Double, D0 As Double, Di0 As Double, _
    Nf As Long, Fd0 As Double, Fw0 As Double, _
    Dti As Double, Dexit As Double, Kn As Double, Exprat As Double, _
    Pbst As Double, Pout As Double, Patm As Double, _
    Isp As Double, Itsum As Double, Tbout As Double, Tthr As Double, _
    Favg As Double, Fmax As Double, TFmax As Double, _
    Pavg As Double, Pmax As Double, TPmax As Double, _
    Ravg As Double, Rmax As Double, _
    Aavg As Double, Amax As Double ', Xdmax As Double

Private Const MinPressure As Double = 0.000000000000001     'Minimum ambient pressure in Pascals
Private Const MaxRatio As Double = 1000                     'Maximum nozzle expansion ratio

Private Sub Form_Load()
    ShowScrollBar Txt.hWnd, 0 'SB_HORZ=0 SB_VERT=1 SB_BOTH=3
    LoadButton CalcNozzle, "Calc.ico": LoadButton CalcCurve, "Save.ico"
    Class.SelectItem 0: Exposed.SelectItem 1
    End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = vbFormControlMenu Then Cancel = True: Activate: Exit Sub
    End Sub

Sub Activate()
    If Main.WindowState = vbMinimized Then Exit Sub
    If Visible Then Hide Else Show vbModeless, Main: DoEvents: Update
    'If Options.SnapPanels Then ResizeMain
    End Sub

Sub Form_Resize()
    Dim N As Single
    If NoResize Or IsInit Then Exit Sub
    N = IfSng(ShowLog, BurnWidthEx, BurnWidth)
    NoResize = True: Move Left, Top, _
        (Round((ScaleWidth - 3) / N) * N + 3 - ScaleWidth) * TwipX + Width, _
        (Round((ScaleHeight - 3) / BurnHeight) * BurnHeight + 3 - ScaleHeight) * TwipY + Height: _
    ResizeBurn: NoResize = False: UpdateLog: Update BurnModeLog
    'If Options.SnapPanels Then ResizeMain
    End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
    Case vbKeyF1 To vbKeyF12, vbKeyEscape: Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case vbKeyC, vbKeyH, vbKeyV, vbKeyX, vbKeyZ
    Case vbKey0 To vbKey9, vbKeyA To vbKeyZ, vbKeySpace, vbKeyTab
        If Shift > 1 Then Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case vbKeyReturn
        If Shift Then Main.Form_KeyDown KeyCode, Shift: KeyCode = 0 _
        Else Update
    Case Else: If Shift > 4 Then Main.Form_KeyDown KeyCode, Shift And Not 4: KeyCode = 0
        End Select
    End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode: Case vbKeySnapshot: Main.Form_KeyUp KeyCode, Shift: End Select
    End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Shift = 0 Then
        If Y < Sep.Top Or X > PicD.Left Then
            If BurnCurveP >= 0 Then Update BurnModeCursor, -2, False
        'ElseIf X > Pic.Left + Pic.Width Then
            'If BurnCurveP < 0 Then Update BurnModeCursor, -1, False
            End If
        End If
    End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then If Y > Sep.Top Then ShowBurnMenu
    End Sub

Private Sub Pic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Shift = 0 Then Update BurnModeCursor, X, False
    End Sub

Private Sub Pic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then ShowBurnMenu
    End Sub

Private Sub Pic_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
    Case vbKeyLeft:     Update BurnModeCursor, -Switch(Shift And 1, 100, Shift = 2, 10, True, 1)
    Case vbKeyRight:    Update BurnModeCursor, Switch(Shift And 1, 100, Shift = 2, 10, True, 1)
    Case vbKeyPageUp:   If BurnCurveT > 0 Then Update BurnModeCursor, -RoundInt(Switch( _
                            Shift And 1, 1, Shift = 2, 0.1, True, 0.01) / BurnCurveT)
    Case vbKeyPageDown: If BurnCurveT > 0 Then Update BurnModeCursor, RoundInt(Switch( _
                            Shift And 1, 1, Shift = 2, 0.1, True, 0.01) / BurnCurveT)
    Case vbKeyHome:     Update BurnModeCursor, 0, False
    Case vbKeyEnd:      Update BurnModeCursor, -1, False
    Case vbKeyDelete:   If Shift = 0 Then SetCursorTime Tbout
    Case vbKeyInsert:   If Shift = 0 Then SetCursorTime TFmax _
                        Else If Shift = 2 Then CopyData
    Case vbKeyC:        If Shift = 2 Then CopyData
    Case vbKeyContextMenu: ShowBurnMenu
        End Select
    End Sub

Private Sub PicD_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim N As Long
    If Tip.Visible Then Tip.Update
    If Button = 1 Then If BurnCurveP >= 0 Then N = PicD.TextHeight(""): If N > 0 Then _
        N = Int(Y / N): If N >= 0 Then BurnCurveD = N: Update BurnModeCursor, -1, False
    End Sub

Private Sub PicD_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim N As Long, S As String
    If Button Then Exit Sub
    If Shift = 0 And BurnCurveP < 0 Then Update BurnModeCursor, -1, False
    N = Int(Y / PicD.TextHeight(""))
    If (IsAdjust And BurnStyle > 0) Or BurnCurveP < 0 Then
        If N >= 0 And N <= UBound(BurnDataToolTip1) Then S = BurnDataToolTip1(N)
    Else
        If N >= 0 And N <= UBound(BurnDataToolTip2) Then S = BurnDataToolTip2(N)
        End If
    Tip.Update S
    End Sub

Private Sub PicD_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then ShowBurnMenu
    End Sub

Private Sub PicH_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Tip.Visible Then Tip.Update
    End Sub

Private Sub PicH_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Tip.Update PicH.Tag
    'If Shift = 0 And BurnCurveP < 0 Then Update BurnModeCursor, -1, False
    If Shift = 0 And BurnCurveP >= 0 Then Update BurnModeCursor, -2, False
    End Sub

Private Sub PicH_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then ShowBurnMenu
    End Sub

Private Sub PicV_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Tip.Visible Then Tip.Update
    End Sub

Private Sub PicV_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Tip.Update PicV.Tag
    'If Shift = 0 And BurnCurveP < 0 Then Update BurnModeCursor, -1, False
    If Shift = 0 And BurnCurveP >= 0 Then Update BurnModeCursor, -2, False
    End Sub

Private Sub PicV_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then ShowBurnMenu
    End Sub

Sub ToggleLog(Optional ByVal Toggle As Boolean)
    If Toggle Then ShowLog = Not ShowLog
    UpdateWidth Me, ShowLog, BurnWidth, BurnWidthEx
    End Sub

Private Sub ShowLog_Click()
    ToggleLog
    End Sub

Private Sub Txt_KeyDown(KeyCode As Integer, Shift As Integer)
    If Tip.Visible Then Tip.Update
    End Sub

Private Sub Txt_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Tip.Visible Then Tip.Update
    End Sub

Private Sub Txt_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim N As Long
    If Button Then Exit Sub
    N = Int(Y / TwipY / Pic.TextHeight("")) + 1 + SendMessage(Txt.hWnd, &HCE&) 'EM_GETFIRSTVISIBLELINE=&HCE
    If Md = 0 And N >= 18 Then N = N + 2 Else If Md = 1 And N >= 16 Then N = N + 4
    If N < 0 Or N > UBound(BurnLogToolTip) Then N = 0
    Tip.Update BurnLogToolTip(N)
    End Sub

Private Sub Propellant_Init()
    Dim A As Long, B As Long, S As String, T As String
    A = 1: Do
        S = GetLine(Propellants, A): If S = "" Then Exit Do
        If InStr(S, "|Solid|") Then B = InStr(2, S, "|"): If B Then _
            T = T & "|" & Mid(S, 2, B - 2)
        Loop
    Propellant.List = Mid(T, 2)
    End Sub

Private Sub Propellant_Click(Item As Integer)
    SelectFuel
    End Sub

Private Sub Class_Click(Item As Integer)
    SelectClass
    End Sub

Private Sub CalcNozzle_Click()
    AdjustParams
    End Sub

Private Sub CalcCurve_Click()
    Update BurnCalc
    End Sub

Private Sub Exposed_Click(Item As Integer)
    Update
    End Sub

Private Sub BurnExp_Init()
    BurnExp.List = LoadListEx(EnginesDir, "*.brn")
    End Sub

Private Sub BurnExp_Click(Item As Integer)
    If Item < 0 Then Exit Sub
    BurnRate = BurnExp: BurnExp = ""
    BurnRate.SetFocus: BurnRate.Refresh: BurnExp.Refresh
    Update
    End Sub

Private Sub BurnRate_Down()
    If BurnExp.SelectedItem <= 0 Then If EditDown(BurnRate) Then Update
    End Sub

Private Sub BurnRate_Up()
    If BurnExp.SelectedItem <= 0 Then If EditUp(BurnRate) Then Update
    End Sub

Private Sub BurnExp_Down()
    If ListDown(BurnExp) Then Update
    End Sub

Private Sub BurnExp_Up()
    If ListUp(BurnExp) Then Update
    End Sub

Private Sub Pressure_Down()
    If EditDown(Pressure) Then Update
    End Sub

Private Sub Pressure_Up()
    If EditUp(Pressure) Then Update
    End Sub

Private Sub Burst_Init()
    ShowBurstMenu
    End Sub
    
Private Sub mnBurst_Click(Index As Integer)
    Burst = InString(mnBurst(Index).Caption, Tab1, " - ")
    DryMass = InString(mnBurst(Index).Caption, " - ")
    Update
    End Sub

Private Sub Burst_Down()
    If ListDown(Burst) Then Update
    End Sub

Private Sub Burst_Up()
    If ListUp(Burst) Then Update
    End Sub

Private Sub EndPressure_Down()
    If EditDown(EndPressure) Then Update
    End Sub

Private Sub EndPressure_Up()
    If EditUp(EndPressure) Then Update
    End Sub

Private Sub DryMass_Down()
    If EditDown(DryMass) Then Update
    End Sub

Private Sub DryMass_Up()
    If EditUp(DryMass) Then Update
    End Sub

Private Sub Efficiency_Down()
    If EditDown(Efficiency) Then Update
    End Sub

Private Sub Efficiency_Up()
    If EditUp(Efficiency) Then Update
    End Sub

Private Sub Chamber_Down()
    If EditDown(Chamber, , 2) Then Update
    End Sub

Private Sub Chamber_Up()
    If EditUp(Chamber, , 2) Then Update
    End Sub

Private Sub Length_Down()
    If EditDown(Length) Then Update
    End Sub

Private Sub Length_Up()
    If EditUp(Length) Then Update
    End Sub

Private Sub Diameter_Down()
    If EditDown(Diameter, , False) Then Update
    End Sub

Private Sub Diameter_Up()
    If EditUp(Diameter, , False) Then Update
    End Sub

Private Sub Thickness_Down()
    If EditDown(Thickness, , False) Then Update
    End Sub

Private Sub Thickness_Up()
    If EditUp(Thickness, , False) Then Update
    End Sub

Private Sub NozzleThroat_Down()
    If EditDown(NozzleThroat) Then Update
    End Sub

Private Sub NozzleThroat_Up()
    If EditUp(NozzleThroat) Then Update
    End Sub

Private Sub NozzleExit_Down()
    If EditDown(NozzleExit) Then Update
    End Sub

Private Sub NozzleExit_Up()
    If EditUp(NozzleExit) Then Update
    End Sub

Private Sub NSeg_Down()
    If EditDown(NSeg) Then Update
    End Sub

Private Sub NSeg_Up()
    If EditUp(NSeg) Then Update
    End Sub

Private Sub CoreLength_Down()
    If EditDown(CoreLength) Then Update
    End Sub

Private Sub CoreLength_Up()
    If EditUp(CoreLength) Then Update
    End Sub

Private Sub CoreDiameter_Down()
    If EditDown(CoreDiameter) Then Update
    End Sub

Private Sub CoreDiameter_Up()
    If EditUp(CoreDiameter) Then Update
    End Sub

Private Sub NFin_Down()
    If EditDown(NFin) Then Update
    End Sub

Private Sub NFin_Up()
    If EditUp(NFin) Then Update
    End Sub

Private Sub FinDepth_Down()
    If EditDown(FinDepth) Then Update
    End Sub

Private Sub FinDepth_Up()
    If EditUp(FinDepth) Then Update
    End Sub

Private Sub FinWidth_Down()
    If EditDown(FinWidth) Then Update
    End Sub

Private Sub FinWidth_Up()
    If EditUp(FinWidth) Then Update
    End Sub

Private Sub File_Init()
    ShowPresetMenu
    End Sub

Private Sub mnLoadPreset_Click()
    LoadBurnPreset
    End Sub

Private Sub mnSavePreset_Click()
    SaveBurnPreset
    End Sub

Private Sub mnDeletePreset_Click()
    If File <> "" Then DeleteFile EnginesDir & File & ".ini", True
    End Sub

Private Sub mnPreset_Click(Index As Integer)
    LoadBurnPreset mnPreset(Index).Caption
    End Sub

Private Sub mnData_Click(Index As Integer)
    BurnCurveD = Index: Update BurnModeCursor
    End Sub

Private Sub mnCalcCurve_Click()
    BurnCalc = BurnModeCurve
    End Sub

Private Sub mnCalcEngine_Click()
    BurnCalc = BurnModeEngine
    End Sub

Private Sub mnGraphLow_Click()
    BurnDef = 0.001: Update
    End Sub

Private Sub mnGraphMed_Click()
    BurnDef = 0.0001: Update
    End Sub

Private Sub mnGraphHigh_Click()
    BurnDef = 0.00001: Update
    End Sub

Private Sub mnBurnGraph_Click()
    BurnStyle = 0: Update BurnModeCursor
    End Sub

Private Sub mnThroatGraph_Click()
    BurnStyle = 1: Update BurnModeCursor
    End Sub

Private Sub mnExitGraph_Click()
    BurnStyle = 2: Update BurnModeCursor
    End Sub

Private Sub mnBurnPreview_Click()
    BurnPreview = IfDbl(BurnPreview <> 0.3, 0.3, 0): Update
    End Sub

Private Sub mnCopyImage_Click()
    CopyImage Pic
    End Sub

Private Sub mnCopyData_Click()
    CopyData
    End Sub

Private Sub mnSaveData_Click()
    SaveGraph
    End Sub

Sub AdjustParams()
    Dim N As Long, D As Double, X As Double, L As Double, M As Double, P As Double, R As Double
    On Error Resume Next
    If Note.Active Then Exit Sub
    Message "Calculating nozzle parameters, please wait ", , True
    AdjustInit True
    
    'Adjust throat diameter
    If Burst = "" Then BurnThroatN = 0: Erase BurnThroat: GoTo Nxt
    N = 1: D = 100: X = 100 - D: R = 0.01: NozzleExit = ""
    Do
        DoEvents: If Not Note.Active Then GoTo Abort
        If N >= BurnThroatN Then BurnThroatN = BurnThroatN + 100: ReDim Preserve BurnThroat(BurnThroatN - 1)
        X = RoundEx(X + D, R): If X <= 0 Or X > 10000 Then GoTo Quit
        NozzleThroat = NumX(X, FMini) & ":1": Update , , , True: If BurnCurveN <= 0 Then GoTo Quit
        With BurnThroat(N)
        .Diameter = Dti: .Thrust = Fmax: .Pressure = Pmax: .Isp = Isp: .Impulse = Itsum
        End With: N = N + 1
        If D = 0 Then Exit Do
        If Pmax - Patm > Pbst Then X = X - D: D = D / 10: _
            If D < R Then D = 0
        Loop
    If N <> BurnThroatN Then BurnThroatN = N: ReDim Preserve BurnThroat(BurnThroatN - 1)
    AdjustSort BurnThroat, BurnThroatN
Nxt:
    'Adjust exit diameter
    N = 1: D = 1: X = 1 - D: R = 0.01: P = 0: M = 0: L = 0
    Do
        DoEvents: If Not Note.Active Then GoTo Abort
        If N >= BurnExitN Then BurnExitN = BurnExitN + 100: ReDim Preserve BurnExit(BurnExitN - 1)
        X = RoundEx(X + D, R): If X < 1 Then D = 0: X = 1 Else If X > 1000 Then GoTo Quit
        NozzleExit = NumX(X, FMini) & ":1": Update , , , True: If BurnCurveN <= 0 Then GoTo Quit
        With BurnExit(N)
        .Diameter = Dexit: .Thrust = Fmax: .Pressure = Pmax: .Isp = Isp: .Impulse = Itsum
        End With: N = N + 1
        If D = 0 Then Exit Do
        If Itsum > M Then M = Itsum: L = X
        If Itsum > P Then P = Itsum _
        Else P = Itsum: D = -D / 10: If Abs(D) < R Then D = 0: X = L
        Loop
    If N <> BurnExitN Then BurnExitN = N: ReDim Preserve BurnExit(BurnExitN - 1)
    AdjustSort BurnExit, BurnExitN
    
    On Error GoTo 0
Done:
    Message
    IsAdjust = BurnThroatN > 0 Or BurnExitN > 0: If Not IsAdjust Then GoTo NoGraph
    Update BurnModeCursor, 0, False
    GoTo Ext
Quit:
    Message "Error calculating nozzle parameters", 2000: DoEvents
    GoTo NoGraph
Abort:
    Message "Nozzle calculation aborted", 2000: DoEvents
NoGraph:
    AdjustInit
Ext:
    End Sub

Private Sub AdjustInit(Optional ByVal Init As Boolean)
    Max.Diameter = 0: Max.Impulse = 0: Max.Isp = 0: Max.Pressure = 0: Max.Thrust = 0
    IsAdjust = False: BurnThroatP = 0: BurnExitP = 0: If Init Then _
        BurnThroatN = 100: BurnExitN = 100: ReDim BurnThroat(BurnCurveN - 1): ReDim BurnExit(BurnCurveN - 1) _
    Else BurnThroatN = 0: BurnExitN = 0: Erase BurnThroat: Erase BurnExit
    End Sub

Private Sub AdjustSort(A() As BurnPointB, D As Long)
    Dim C As Long, E As Long, N As Long, P As Long, Z As Double, B() As BurnPointB
    If D > 0 Then ReDim B(D - 1) Else Exit Sub
    N = 1: For P = 1 To D - 1: E = 0: Z = Infinite
        For C = 1 To D - 1
            If A(C).Diameter < Z Then Z = A(C).Diameter: E = C
            Next
        If N > 0 Then If A(E).Diameter = B(N - 1).Diameter Then GoTo NoCopy
        B(N) = A(E): N = N + 1
NoCopy:
        A(E).Diameter = Infinite
        Next
    If N > 0 And N <> D Then D = N: ReDim Preserve B(D - 1)
    For C = 1 To D - 1
        If B(C).Diameter > Max.Diameter Then Max.Diameter = B(C).Diameter
        If B(C).Impulse > Max.Impulse Then Max.Impulse = B(C).Impulse
        If B(C).Isp > Max.Isp Then Max.Isp = B(C).Isp
        If B(C).Pressure > Max.Pressure Then Max.Pressure = B(C).Pressure
        If B(C).Thrust > Max.Thrust Then Max.Thrust = B(C).Thrust
        Next
    A = B
    End Sub

Sub UpdateLog(Optional Text As String)
    If Text <> "" Then Txt = Text: Txt.Refresh
    ShowScrollBar Txt.hWnd, 1, -(SendMessage(Txt.hWnd, &HBA&) * TextHeight("") > Txt.Height) 'SB_VERT=1
    End Sub

Sub SelectClass(Optional ByVal N As Long = -1, Optional ByVal UpdateGraph As Boolean = True)
    If N >= 0 Then Class.SelectItem N
    N = Class.SelectedItem
    NSeg.Visible = N <> 1
    Exposed.Visible = N <> 1
    CoreLength.Visible = N <> 1
    CoreDiameter.Visible = N <> 1
    NFin.Visible = N = 2
    FinDepth.Visible = N = 2
    FinWidth.Visible = N = 2
    If UpdateGraph Then Update
    End Sub

Sub SelectFuel(Optional Fuel As String, Optional ByVal UpdateGraph As Boolean = True)
    Dim A As Long, D As Long, N As Long, Q As Single, S As String, _
        C As CPropellant, Chamber As String, Nozzle As String, Ratio As String, _
        Mix As String, Component As String
    On Error Resume Next
    '|APCP|70%|Ammonium Perchlorate (AP)|10%|Styrene|20%|Aluminum (Pure Crystaline)||33atm|1atm|5.4:1|3635K|1.900g/cm|37.85$/kg|Solid|Finocyl 5-Star|0|5%|258.7s|233.4s
    If Fuel <> "" Then Propellant = Fuel
    'File = Propellant
    A = InStr(Propellants, "|" & Propellant & "|"): If A = 0 Then Exit Sub
    S = GetLine(Propellants, A + 1): ParamB S
    N = 1: For A = 1 To ComponentMax
        Mix = ParamB(S): If Val(Mix) <= 0 Then Exit For
        Component = ParamB(S): If Component = "" Then Exit For
        Q = ValMass(Mix, 0.1) * 1000: D = CodeCP(UCase(Component))
        If Q > 0 And D >= 0 Then C.Comp(N).Code = D: C.Comp(N).Mass = Q: N = N + 1
        Next
    Chamber = ParamB(S): Nozzle = ParamB(S): Ratio = ParamB(S) ': Temp = ParamB(S)
    'Density = ParamB(S): Cost = ParamB(S): Class = ParamB(S): Curve = ParamB(S)
    'Hypergolic = NumB(S) <> 0: Volume = ParamB(S): IspV = ParamB(S): IspSL = ParamB(S)
    If N > 1 Then C.Components = N - 1 Else Exit Sub
    C.Mode = 2 'FROZEN_PERFORMANCE
    C.ChamberPressure = ValPressure(Chamber) / Pascal
    If Nozzle = "" Then C.ExitPressure = ValRatio(Ratio): C.ExitMode = 1 _
    Else C.ExitPressure = ValPressure(Nozzle) / Pascal: C.ExitMode = 2 'SUPERSONIC_AREA_RATIO=1 PRESSURE=2
    ExecuteCP C: Q = Q * Q
    If C.Density > 0 Then _
        UpdateFuel C.Prop(0).T, C.Density, C.Prop(0).M, C.Prop(0).Cp / C.Prop(0).Cv, UpdateGraph
    On Error GoTo 0
    End Sub

Sub UpdateFuel(T As Double, D As Double, M As Double, Kmix As Double, _
        Optional ByVal UpdateGraph As Boolean = True)
    On Error Resume Next
    If Units Then If RelativeTemp Then Temp = NumX(T * 1.8 - 459.67, FZero) & "F" _
        Else Temp = NumX(T * 1.8 + 0.02, FZero) & "R" _
    Else If RelativeTemp Then Temp = NumX(T - Kelvin, FZero) & "C" _
        Else Temp = NumX(T, FZero) & "K"
    If Units Then Density = NumX(D * 1000 / Pound * Foot3, FOne) & "lb/ft" _
    Else Density = NumX(D, FShort) & "g/cm"
    If Units Then Mol = NumX(M / 1000 / Pound, FShort) & "lb/mol" _
    Else Mol = NumX(M, FShort) & "g/mol"
    Kmix = NumX(Kmix, FShort)
    K2ph = ""
    On Error GoTo 0
    If UpdateGraph Then Update
    End Sub

Private Function ToSec(N As Double) As String
         If N >= 10000 Then ToSec = NumA(N, FMini) & "s" _
    Else If N >= 1000 Then ToSec = NumA(N, FShort) & "s" _
    Else If N >= 100 Then ToSec = NumA(N, FQuad) & "s" _
    Else If N >= 10 Then ToSec = NumA(N, FFive) & "s" _
    Else If N >= 1 Then ToSec = NumA(N, FLong) & "s" _
                  Else ToSec = NumA(N, FShort) & "s"
    End Function

Private Function ToStress(N As Double) As String
    If Units Then _
         ToStress = Replace(Format(RoundEx(N * 1000000 / Psi, 10000), "#,0"), ".", ",") & "psi" _
    Else ToStress = Replace(Format(N, FZero), ",", ".") & "MPa"
    End Function

Private Function ToMaterial(N As Double) As String
    If Units Then _
         ToMaterial = Replace(Format(N * 1000 / Pound * Foot3, FZero), ",", ".") & "lb/ft" _
    Else ToMaterial = Replace(Format(N, FOne), ",", ".") & "g/cm"
    End Function

Private Function ToStressDensity(N As Double, D As Double) As String
    ToStressDensity = ToStress(N) & " - " & ToMaterial(D)
    End Function

Sub SetCursorTime(Optional T As Double)
    BurnCurveP = RoundInt(T / BurnCurveT): Update BurnModeCursor
    End Sub

Function LoadCurve(Name As String) As Boolean
    Dim A As Long, S As String, T As String
    If Name = "" Then Exit Function
    T = LoadFile(EnginesDir & Name & ".brn"): If T = "" Then Exit Function
    A = 1: Do
        S = GetLine(T, A): If S = "" Then Exit Function
        Loop While Left(S, 1) = ";"
    PressureCurveN = 0: ReDim PressureCurve(0)
    Do
        S = GetLine(T, A): If S = "" Or Left(S, 1) = ";" Then Exit Do
        If PressureCurveN > 0 Then ReDim Preserve PressureCurve(PressureCurveN)
        With PressureCurve(PressureCurveN)
        .P = ParamN(S) * 1000000: .A = ParamN(S): .N = ParamN(S)
        End With
        PressureCurveN = PressureCurveN + 1
        Loop
    LoadCurve = PressureCurveN > 0
    End Function

Sub Update( _
        Optional ByVal Mode As BurnMode = BurnModeFast, Optional ByVal Pos As Long, _
        Optional ByVal Relative As Boolean = True, Optional ByVal Force As Boolean)
    
    Dim C As Long, Q As Long, N As Long, G As Double, I As Double, J As Boolean, S As String, _
        C0 As Long, C1 As Long, C2 As Long, C3 As Long, _
        P As Single, WW As Single, HH As Single, _
        Dp As Double, Dpf As Double, Bp As Double, Cp As Double, Np As Double, _
        W As Single, H As Single, X As Single, Y As Single, Z As Single, _
        T2 As Double, SX As Double, SY As Double, MX As Double, MY As Double, SX2 As Double, _
        PX As Double, PY As Double, PX2 As Double, PY2 As Double, PX3 As Double, PY3 As Double, _
        PPX As Long, PPY As Long, PPX2 As Long, PPY2 As Long, PPX3 As Long, PPY3 As Long, _
        Lgx As Long, Lcx As Long, Dcx As Long, _
        Ldx As Long, Dix As Long, Fdx As Long, Fwx As Long, Tnx As Long, _
        Ci As Long, Xi As Long, Ni As Long, Fi As Long, Bi As Long, _
        Lt As Double, Ln As Double, Lf As Double, Lb As Double, Rc As Double, Re As Double, _
        K As Double, K2 As Double, Etanoz As Double, Rmt As Double, _
        Kpe As Double, Knoz As Double, Kte1 As Double, Kte2 As Double, Kve As Double, _
        K2s1 As Double, K2p1 As Double, Kme As Double, Kme1 As Double, Kme2 As Double, _
        Vc As Double, Vt As Double, _
        Ab As Double, Abn As Double, Abf As Double, Abb As Double, Abc As Double, Abx As Double, _
        At As Double, Aexit As Double, _
        Lm As Double, Ls As Double, Di As Double, D As Double, Two As Double, Xd As Double, _
        Tn As Double, Xincp As Double, Rhopgrain As Double, Mw As Double, Tc As Double, _
        Pa As Double, Pn As Double, R As Double, A As Double, T As Double, dT As Double, _
        Vgrain As Double, Vfree As Double, Mgrain As Double, Mgrainl As Double, _
        Mgen As Double, Mnoz As Double, Msto As Double, Pprod As Double, _
        Pc As Double, Pt As Double, Pe As Double, Tt As Double, Te As Double, _
        Ve As Double, F As Double, Cfnnoz As Double, Mex As Double, Fd As Double, Fw As Double
    Static IsBusy As Boolean
    
    If Not Visible Or IsBusy Or (Note.Active And Not Force) Then Exit Sub
    If BurnCurveD < 0 Then BurnCurveD = 0 Else If BurnCurveD > 3 Then BurnCurveD = 3
    If Mode <= BurnModeLog Then If BurnCurveN > 0 Then GoTo NoCalc _
        Else If Msg <> "" Then GoTo ExtMsg Else Exit Sub
    
    On Error GoTo Ext
    
    Msg = "": If IsAdjust Then AdjustInit
    Md = Class.SelectedItem: Gc = Class: If Md < 0 Then Md = 0
    Etanoz = ValRatio(Efficiency): If Etanoz <= 0 Then _
        Msg = "Nozzle efficiency out of range": GoTo Ext            'Nozzle efficiency
    Patm = ValPressure(Pressure): If Patm < 0 Then _
        Msg = "External pressure out of range": GoTo Ext            'Ambient pressure
    If Patm < MinPressure Then Patm = MinPressure
    If Burst = "" Then Pbst = Infinite _
    Else Pbst = ValPressure(Burst): If Pbst < 0 Then _
        Msg = "Maximum pressure out of range": GoTo Ext             'Limit pressure
    Pout = Patm + ValPressure(EndPressure): If Pout <= Patm Then _
        Msg = "End of thrust pressure out of range": GoTo Ext       'Ambient pressure
    
    K = Val(Kmix): If K <= 0 Then _
        Msg = "Kmix parameter out of range": GoTo Ext               'Ratio of specific heats of mixture
    If K2ph = "" Then K2 = K _
    Else K2 = Val(K2ph): If K2 <= 0 Then _
        Msg = "K2ph parameter out of range": GoTo Ext               'Ratio of specific heats of two phase flow
    Mw = Val(Mol): If Mw <= 0 Then _
        Msg = "Molar mass out of range": GoTo Ext                   'Effective molar mass
    'Rat = Runiv / Mw                                                'Specific gas constant
    Tc = ValTemp(Temp): If Tc <= 0 Then _
        Msg = "Chamber temperature out of range": GoTo Ext          'Chamber temperature
    Rhopgrain = ValDensity(Density): If Rhopgrain <= 0 Then _
        Msg = "Propellant density out of range": GoTo Ext           'Propellant density
    Pa = ValSpace(BurnRate): Pn = Val(BurnExp)                      'Linear burn rate and exponential parameter
    If Pa > 0 And Pn >= 0 Then PressureCurveN = 0 _
    Else Pa = 0.001: Pn = 0: If Not LoadCurve(BurnRate) Then _
        Msg = "Burn rate out of range": GoTo Ext                    'Pressure to burn rate curve
    
    If Md = 1 Then Ng = 1 _
    Else Ng = Int(Val(NSeg)): If Ng <= 0 Then _
        Msg = "Number of segments out of range": GoTo Ext           'Number of segments
    If IsRatio(Chamber) Then Lcx = 1: Lc = ValRatio(Chamber) _
    Else If IsVolume(Chamber) Then Lcx = 2: Lc = ValVolume(Chamber) _
    Else If IsMass(Chamber) Then Lcx = 2: Lc = ValMass(Chamber) / Rhopgrain _
    Else Lcx = 0: Lc = ValSpace(Chamber)                            'Chamber length
    If IsRatio(Length) Then Lgx = 1: Lg = ValRatio(Length) _
    Else If IsVolume(Length) Then Lgx = 2: Lg = ValVolume(Length) _
    Else If IsMass(Length) Then Lgx = 2: Lg = ValMass(Length) / Rhopgrain _
    Else Lgx = 0: Lg = ValSpace(Length)                             'Propellant length
    If IsRatio(Diameter) Then Dcx = 1: Dc = ValRatio(Diameter) _
    Else If IsVolume(Diameter) Then Dcx = 2: Dc = ValVolume(Diameter) _
    Else If IsMass(Diameter) Then Dcx = 2: Dc = ValMass(Diameter) / Rhopgrain _
    Else Dcx = 0: Dc = ValSpace(Diameter)                           'Chamber diameter
    If Md = 1 Then Ldx = 0: Ld = 0 _
    Else If IsRatio(CoreLength) Then Ldx = 1: Ld = ValRatio(CoreLength) _
    Else Ldx = 0: Ld = ValSpace(CoreLength)                         'Core length
    If Md = 1 Then Dix = 0: Di0 = 0 _
    Else If IsRatio(CoreDiameter) Then Dix = 1: Di0 = ValRatio(CoreDiameter) _
    Else Dix = 0: Di0 = ValSpace(CoreDiameter)                      'Core diameter
    If Md <= 1 Then Nf = 0 _
    Else Nf = Int(Val(NFin)): If Nf < 1 Then _
        Msg = "Number of fins out of range": GoTo Ext               'Number of fins
    If Md <= 1 Then Fdx = 0: Fd0 = 0 _
    Else If IsRatio(FinDepth) Then Fdx = 1: Fd0 = ValRatio(FinDepth) _
    Else Fdx = 0: Fd0 = ValSpace(FinDepth)                           'Fin depth
    If Md <= 1 Then Fwx = 0: Fw0 = 0 _
    Else If IsRatio(FinWidth) Then Fwx = 1: Fw0 = ValRatio(FinWidth) _
    Else Fwx = 0: Fw0 = ValSpace(FinWidth)                           'Fin width
    If IsRatio(Thickness) Then Tnx = 1: Tn = ValRatio(Thickness) _
    Else Tnx = 0: Tn = ValSpace(Thickness)                          'Chamber thickness
    
    If Lc <= 0 Or Lg <= 0 Or Dc <= 0 Or Ld < 0 Or Di0 < 0 Then GoTo DoSize
    If Lcx = 1 Then
        If Lgx = 1 Then GoTo NoSize
        If Lgx = 2 Then
            If Dcx = 0 And Ldx = 0 And Dix = 0 Then _
                Lg = (Lg + Ng * Ld * Di0 * Di0 * Pi / 4) / (Dc * Dc * Pi / 4): Lgx = 0 _
            Else GoTo NoSize 'L=(v+l*d^2*pi/4)/(D^2*pi/4)
            End If
        Lc = Lc * Lg: Lcx = 0
    ElseIf Lcx = 2 Then
        If Dcx = 1 Then
            If Lgx = 0 Then Dc = Dc * Lg: Dcx = 0 _
            Else GoTo NoSize
        ElseIf Dcx = 2 Then
            If Lgx = 0 And Ldx = 0 And Dix = 0 Then _
                Dc = Sqr((Dc + Ng * Ld * Di0 * Di0 * Pi / 4) / (Lg * Pi / 4)): Dcx = 0 _
            Else GoTo NoSize 'D=Sqr((v+l*d^2*pi/4)/(L*pi/4))
            End If
        Lc = Lc / Dc / Dc / Pi * 4: Lcx = 0
        End If
    If Lgx = 1 Then
        If Lcx = 1 Then GoTo NoSize
        If Lcx = 2 Then _
            If Dcx = 0 Then Lc = Lc / Dc / Dc / Pi * 4: Lcx = 0 _
            Else GoTo NoSize
        Lg = Lg * Lc: Lgx = 0
    ElseIf Lgx = 2 Then
        If Dcx = 0 Then
                If Ldx = 0 And Dix = 0 Then 'L=(v+l*d^2*pi/4)/(D^2*pi/4)
                Lg = (Lg + Ng * Ld * Di0 * Di0 * Pi / 4) / (Dc * Dc * Pi / 4)
            ElseIf Ldx = 1 And Dix = 0 Then 'L=v/(D^2*pi/4-rl*d^2*pi/4)
                Lg = Lg / (Dc * Dc * Pi / 4 - Ld * Di0 * Di0 * Pi / 4)
            ElseIf Ldx = 0 And Dix = 1 Then 'L=(v+l*rd^2*D^2*pi/4)/(D^2*pi/4)
                Lg = (Lg + Ng * Ld * Di0 * Di0 * Dc * Dc * Pi / 4) / (Dc * Dc * Pi / 4)
            ElseIf Ldx = 1 And Dix = 1 Then 'L=v/(D^2*pi/4-rl*rd^2*D^2*pi/4)
                Lg = Lg / (Dc * Dc * Pi / 4 - Ld * Di0 * Di0 * Dc * Dc * Pi / 4)
            Else
                GoTo NoSize
                End If
            Lgx = 0
        Else
            GoTo NoSize
            End If
        End If
    If Dcx = 1 Then
        If Lgx = 0 Then Dc = Dc * Lg: Dcx = 0 _
        Else GoTo NoSize
    ElseIf Dcx = 2 Then
        If Lgx = 0 Then
                If Ldx = 0 And Dix = 0 Then 'D=Sqr((v+l*d^2*pi/4)/(L*pi/4))
                Dc = Sqr((Dc + Ng * Ld * Di0 * Di0 * Pi / 4) / (Lg * Pi / 4))
            ElseIf Ldx = 1 And Dix = 0 Then 'D=Sqr((v+rl*L*d^2*pi/4)/(L*pi/4))
                Dc = Sqr((Dc + Ld * Lg * Di0 * Di0 * Pi / 4) / (Lg * Pi / 4))
            ElseIf Ldx = 0 And Dix = 1 Then 'D=Sqr(v/(L*pi/4-l*rd^2*pi/4))
                Dc = Sqr(Dc / (Lg * Pi / 4 - Ng * Ld * Di0 * Di0 * Pi / 4))
            ElseIf Ldx = 1 And Dix = 1 Then 'D=Sqr(v/(L*pi/4-rl*L*rd^2*pi/4))
                Dc = Sqr(Dc / (Lg * Pi / 4 - Ld * Lg * Di0 * Di0 * Pi / 4))
            Else
                GoTo NoSize
                End If
            Dcx = 0
        Else
            GoTo NoSize
            End If
        End If
NoSize:
    If Lcx > 0 Or Lgx > 0 Or Dcx > 0 Then _
        Msg = "Propellant or core sizes not specified": GoTo Ext
DoSize:
    If Lc <= 0 Then _
        Msg = "Chamber length out of range": GoTo Ext
    If Lg <= 0 Then _
        Msg = "Propellant length out of range": GoTo Ext
    If Dc <= 0 Then _
        Msg = "Chamber diameter out of range": GoTo Ext
    L0 = Lg / Ng: If L0 * Ng > Lc Then _
        Msg = "Propellant does not fit in chamber": GoTo Ext
    D0 = Dc: If D0 <= 0 Or D0 > Dc Then _
        Msg = "Propellant diameter out of range": GoTo Ext
    If Ldx = 1 Then Ld = Ld * L0
    If Ld < 0 Or Ld > L0 Then _
        Msg = "Core length out of range": GoTo Ext
    If Dix = 1 Then Di0 = Di0 * D0
    If Di0 < 0 Or Di0 >= D0 Then _
        Msg = "Core diameter out of range": GoTo Ext
    If Nf < 1 Then Nf = 0: GoTo NoFin
    If Fdx = 1 Then Fd0 = Fd0 * D0 / 2
    If Fd0 < 0 Then _
        Msg = "Fin depth out of range": GoTo Ext 'Fd0 > (D0 - Di0) / 2
    If Fwx = 1 Then Fw0 = Fw0 * D0 / 2
    If Fw0 < 0 Then _
        Msg = "Fin width out of range": GoTo Ext 'Fw0 > Di0 * Pi / Nf
NoFin:
    If Tnx = 1 Then Tn = Tn * Dc
    If Tn <= 0 Then _
        Msg = "Chamber thickness out of range": GoTo Ext
    Rc = Dc / 2: Re = Rc + Tn: De = Dc + Tn * 2
    If InStr(Burst, "Pa") Or InStr(Burst, "psi") Then _
        If Pbst < Infinite Then Pbst = IsMin( _
            Pbst * (Re * Re - Rc * Rc) / Rc / Rc, Pbst * (Re - Rc) / Rc) 'Cross and longitudinal pressure limits
    
    If Md = 1 Then Ei = 1 _
    Else Ei = Exposed.SelectedItem: If Ei < 0 Or Ei > 2 Then Ei = 1 'Propellant ends exposed
    Ni = -(Ei >= 1)                                                 'Propellant nozzle end exposed
    Bi = -(Ei >= 2)                                                 'Propellant base end exposed
    Fi = 1                                                          'Propellant core base exposed
    Ci = 1                                                          'Propellant core walls exposed
    Xi = 0                                                          'Propellant outer surface exposed
    
    If Ng <= 0 Then _
        Msg = "Number of segments out of range": GoTo Ext           'Number of segments
    L0 = Lg / Ng: Lb = 0: Ln = L0: If Ln <= 0 Then _
        Msg = "Propellant length out of range": GoTo Ext            'Initial propellant length
    Lf = Ln - Ld: If Lf < 0 Then _
        Msg = "Core length out of range": GoTo Ext                  'Initial core length
    If Lf > 0 And (Ng > 1 Or Bi = 1) Then _
        Msg = "Invalid core length": GoTo Ext
    D = D0: If D <= 0 Or D > Dc Then _
        Msg = "Propellant diameter out of range": GoTo Ext          'Initial propellant diameter
    Di = Di0: If Di < 0 Or Di >= D Then _
        Msg = "Core diameter out of range": GoTo Ext                'Initial core diameter
    Two = (D - Di) / 2                                              'Propellant thickness
    Fd = Fd0: Fw = Fw0                                              'Initial fin depth and width
    
    Abb = D * D * Pi / 4                                            'Base end burning area
    If Nf Then Abf = FinArea(Nf, Di0, D0, Fd0, Fw0) _
    Else Abf = Di * Di * Pi / 4                                     'Core base burning area
    Abn = Abb - Abf                                                 'Nozzle end burning area
    
    Vg = 0
    Ls = Lf - Lb: If Ls > 0 Then Vg = Vg + Abb * Ls _
    Else Lf = Lb: Ls = 0                                            'Propellant base section volume
    Lm = Ln - Lf: If Lm > 0 Then Vg = Vg + Abn * Lm _
    Else Ln = Lf: Lm = 0                                            'Propellant nozzle section volume
    Lt = Ls + Lm                                                    'Propellant total length
    Vg = Vg * Ng: If Vg <= 0 Then _
        Msg = "Propellant volume out of range": GoTo Ext            'Propellant volume
    Vc = Dc * Dc * Pi / 4 * Lc: If Vc <= 0 Then _
        Msg = "Chamber volume out of range": GoTo Ext               'Chamber volume
    Vfree = Vc - Vg: If Vfree <= 0 Then _
        Msg = "Chamber free volume out of range": GoTo Ext          'Chamber free volume
    Vt = Vg / Vc                                                    'Propellant loading ratio
    Mg = Rhopgrain * Vg                                             'Propellant mass
    If IsVolume(DryMass) Then Mc = ValDensity(DryMass) * _
        (Lc * (Re * Re - Rc * Rc) + Tn * Re * Re * 2) * Pi _
    Else Mc = ValMass(DryMass, Mg, True)
    If Mc <= 0 Then _
        Msg = "Dry mass out of range": GoTo Ext                     'Dry mass
    Mt = Mc + Mg                                                    'Total mass
    
    Ab = 0
    If Bi Then If Ls > 0 Then Ab = Ab + Abb Else Ab = Ab + Abn      'Base end burning area
    If Fi Then If Ls > 0 Then Ab = Ab + Abf                         'Core base burning area
    If Ni Then Ab = Ab + Abn                                        'Nozzle end burning area
    If Nf Then Abc = FinArea(Nf, Di0, D0, Fd0, Fw0, True) * Lm _
    Else Abc = Di * Pi * Lm                                         'Core walls burning area
    If Ci Then Ab = Ab + Abc
    Abx = D * Pi * Lt: If Xi Then Ab = Ab + Abx                     'Outer surface burning area
    Ab = Ab * Ng: If Ab <= 0 Then _
        Msg = "Burn area out of range": GoTo Ext                    'Burning area
    
    If IsRatio(NozzleThroat) Then
        Kn = ValRatio(NozzleThroat): If Kn <= 0 Then _
            Msg = "Burn to throat ratio out of range": GoTo Ext     'Burning area to throat area ratio
        At = Ab / Kn: Dti = Sqr(At / Pi * 4)
    ElseIf InStr(NozzleThroat, "") Or InStr(NozzleThroat, "m2") Or _
            InStr(NozzleThroat, "in2") Or InStr(NozzleThroat, "ft2") Then
        At = ValArea(NozzleThroat): If At <= 0 Then _
            Msg = "Nozzle throat area out of range": GoTo Ext       'Throat area
        Dti = Sqr(At / Pi * 4): Kn = Ab / At
    Else
        Dti = ValSpace(NozzleThroat): If Dti <= 0 Then _
            Msg = "Nozzle throat diameter out of range": GoTo Ext   'Throat diameter
        At = Dti * Dti * Pi / 4: Kn = Ab / At
        End If
    If Dti > Dc Then Dti = Dc: At = Dti * Dti * Pi / 4: Kn = Ab / At
    If NozzleExit = "" Then
        Exprat = 0: Aexit = At: Dexit = Sqr(Aexit / Pi * 4)
    Else
        If IsRatio(NozzleExit) Then
            Exprat = ValRatio(NozzleExit): If Exprat >= 1 Then _
                Aexit = At * Exprat: Dexit = Sqr(Aexit / Pi * 4)    'Exit area to throat area ratio
        ElseIf InStr(NozzleExit, "") Or InStr(NozzleExit, "m2") Or _
                InStr(NozzleExit, "in2") Or InStr(NozzleExit, "ft2") Then
            Aexit = ValArea(NozzleExit): If Aexit <= 0 Then _
                Msg = "Nozzle exit area out of range": GoTo Ext     'Exit area
            Dexit = Sqr(Aexit / Pi * 4): Exprat = Aexit / At
        Else
            Dexit = ValSpace(NozzleExit): If Dexit <= 0 Then _
                Msg = "Nozzle exit diameter out of range": GoTo Ext 'Exit diameter
            Aexit = Dexit * Dexit * Pi / 4: Exprat = Aexit / At
            End If
        If Exprat < 1 Then _
            Msg = "Nozzle expansion ratio out of range": GoTo Ext
        End If
    
    Vgrain = Vg                                                     'Initial propellant volume
    Mgrain = Mg                                                     'Initial propellant mass
    Cfnnoz = Etanoz                                                 'Delivered cf
    If Patm < MinPressure Then Patm = MinPressure                   'Limit minimum ambient pressure
    Pc = Patm                                                       'Initial chamber pressure
    Pe = Patm                                                       'Initial nozzle exit pressure
    A = Exprat: If A < 1 Then A = 1                                 'Initial nozzle expansion ratio
    Mex = 1                                                         'Initial nozzle exit Mach number
    If Exprat >= 1 Then
        I = 0: For C = 1 To 1000                                    'Find nozzle exit Mach number
            G = I: I = (((K2 + 1) / 2) ^ (-(K2 + 1) / (K2 - 1) / 2)) / Mex * _
                (1 + (K2 - 1) / 2 * Mex * Mex) ^ ((K2 + 1) / (K2 - 1) / 2) / Exprat
            If Abs(I - G) <= 0.000000000001 Then Exit For
            Mex = Mex / ((I - 1) / 5 + 1)
            Next
        End If
    dT = NumRound(BurnDef / 10 * IfDbl(Ld > 0, Two, Ln) / Pa): _
        If dT <= 0 Then GoTo Ext                                    'Simulation time step
    'Xincp = Two / 1000: If Xincp <= 0 Then GoTo Ext                 'Propellant burn step
    Rmt = Runiv / Mw * Tc                                           'Constant values
    Kve = Runiv / Mw * K2
    Kte2 = (K2 - 1) / 2
    Kte1 = 1 + Mex * Mex * Kte2
    Kpe = Kte1 ^ (K2 / (1 - K2))
    K2s1 = K2 - 1
    K2p1 = K2 + 1
    Kme1 = 2 / K2s1
    Kme2 = K2s1 / K2
    Kme = K2p1 / K2s1 / 2
    Knoz = Sqr(Rmt / K) / (2 / (K + 1)) ^ ((K + 1) / (K - 1) / 2)
    F = 0: Ve = 0: Xd = 0: R = 0: Vfree = 0: Mgen = 0: Mnoz = 0: Itsum = 0
    Tbout = 0: Tthr = 0: Favg = 0: Fmax = 0: TFmax = 0
    Pavg = 0: Pmax = 0: TPmax = 0: Ravg = 0: Rmax = 0: Aavg = 0: Amax = 0
    N = 0: BurnCurveN = 0: BurnCurveM = 1000: ReDim BurnCurve(BurnCurveM - 1) 'Data matrix
    IsBusy = True: T2 = TimerEx + 1
    
    Do
        
        'Cancel detection
        If (N And &H7FFF&) = 0 Then If TimerEx > T2 Then _
            If Not Note.Visible Then Message "Calculating simulation, please wait ", , True: DoEvents _
            Else DoEvents: If Not Note.Active Then Message: Msg = "Burn simulation aborted": GoTo Ext
        
        'Copy simulation data for the graph
        If N >= BurnCurveM Then If BurnCurveM < 1000000 Then _
                BurnCurveM = BurnCurveM * 2: ReDim Preserve BurnCurve(BurnCurveM - 1) _
            Else Msg = "Simulation time too long": GoTo Ext
        BurnCurve(N).Thrust = F: BurnCurve(N).Pressure = Pc: BurnCurve(N).Burn = Xd
        BurnCurve(N).BurnRate = R: BurnCurve(N).ExpRatio = A
        'BurnCurve(N).Volume = Vfree: BurnCurve(N).Mass = Mgrain
        'BurnCurve(N).BurnFlow = Mgen: BurnCurve(N).NozzleFlow = Mnoz
        'BurnCurve(N).NozzleEnd = Ln: BurnCurve(N).CoreBase = Lf: BurnCurve(N).BaseEnd = Lb
        N = N + 1
        
        'Detect burn out and end of thrust
        If Vgrain <= 0 Then                                         'Burn out detection
            If Tbout = 0 Then Tbout = T - dT: _
                If Tbout <= 0 Then Tbout = 0: Ravg = 0 _
                Else Ravg = Xd / Tbout                              'Burn out time and average burn rate
            If Pc <= Pout Then Exit Do                              'End of thrust detection
            T = Int(T / dT + 1.5) * dT                              'Increment simulation time
            GoTo NoVolume
        Else
            T = Int(T / dT + 1.5) * dT                              'Increment simulation time
            End If
        
        'Propellant burn rate
        If PressureCurveN <= 0 Then
            R = Pa * (Pc / Pascal) ^ Pn
        Else
            C = 0: Do While C < PressureCurveN - 1
                If Pc >= PressureCurve(C + 1).P Then C = C + 1 Else Exit Do
                Loop
            Pa = PressureCurve(C).A: Pn = PressureCurve(C).N
            R = Pa * (Pc / 1000000) ^ Pn / 1000
            End If
        'dT = Xincp / R
        Xincp = R * dT: Xd = Xd + Xincp
        
        'Propellant regression
        If Xi Then D = D - Xincp - Xincp: If D < 0 Then D = 0       'Outer surface regression
        If Ci Then Di = Di + Xincp + Xincp: If Di >= D Then Di = D  'Core walls regression
        If Nf Then Fw = Fw + Xincp + Xincp                          'Fin walls regression
        If Ni Then Ln = Ln - Xincp                                  'Nozzle end regression
        If Fi Then Lf = Lf - Xincp                                  'Core base regression
        If Bi Then Lb = Lb + Xincp                                  'Base end regression
        
        'Propellant volume
        Vgrain = 0
        If Lf <= Lb Then Lf = Lb _
        Else Vgrain = Vgrain + D * D * Pi / 4 * (Lf - Lb)           'Propellant base section
        If Ln <= Lf Then Ln = Lf _
        Else If Di < D Then If Nf Then Vgrain = Vgrain + _
                (D * D * Pi / 4 - FinArea(Nf, Di, D, Fd, Fw)) * (Ln - Lf) _
            Else Vgrain = Vgrain + (D * D - Di * Di) * Pi / 4 * (Ln - Lf) 'Propellant nozzle section
        Vgrain = Vgrain * Ng: If Vgrain <= Vg / 1E+15 Then Vgrain = 0: R = 0 'Propellant volume
NoVolume:
        
        'Burned flow and nozzle flow
        Vfree = Vc - Vgrain
        Mgrainl = Mgrain: Mgrain = Rhopgrain * Vgrain               'Burned mass
        Mgen = (Mgrainl - Mgrain) / dT                              'Burned flow
        Mnoz = (Pc - Patm) * At / Knoz                              'Nozzle flow
        'Mnoz = (Pc - Patm) * At / Sqr(Runiv / Mw * Tc / K) * (2 / (K + 1)) ^ ((K + 1) / 2 / (K - 1))
        
        'Combustion chamber pressure
        Msto = Msto + (Mgen - Mnoz) * dT                            'Chamber gas mass
        Pprod = Msto / Vfree                                        'Chamber gas density
        Pc = Pprod * Rmt + Patm                                     'Chamber pressure
        'Pc = Pprod * Runiv / Mw * Tc + Patm
        If Pc < Patm Then Pc = Patm
        Pavg = Pavg + Pc * dT
        
        'Thrust and total impulse
        'Pt = Pc / (1 + (K - 1) / 2) ^ (K / (K - 1))                 'Pressure at nozzle throat
        'Tt = Tc / (1 + (K - 1) / 2)                                 'Temperature at nozzle throat
        If Exprat >= 1 Then
            Pe = Pc * Kpe                                           'Pressure at nozzle exit
            'Pe = Pc * (1 + Mex * Mex * (K2 - 1) / 2) ^ (K2 / (1 - K2))
            Te = Tc / Kte1                                          'Temperature at nozzle exit
            'Te = Tc / (1 + Mex * Mex * (K2 - 1) / 2)
        Else
            Mex = Sqr(Kme1 * ((Pc / Pe) ^ Kme2 - 1))                'Mach number at nozzle exit
            'Mex = Sqr((2 / (K2 - 1)) * ((Pc / Pe) ^ ((K2 - 1) / K2) - 1))
            If Mex <= 1 Then
                A = 1: Aexit = At
            Else
                A = ((2 + K2s1 * Mex * Mex) / K2p1) ^ Kme / Mex     'Ideal nozzle expansion ratio
                'A = ((2 + (K2 - 1) * Mex * Mex) / (K2 + 1)) ^ ((K2 + 1) / (K2 - 1) / 2) / Mex
                If A > MaxRatio Then A = MaxRatio
                End If
            Aexit = At / A                                          'Ideal nozzle exit diameter
            Aavg = Aavg + A * dT                                    'Average nozzle expansion ratio
            Te = Tc / (1 + Mex * Mex * Kte2)                        'Temperature at nozzle exit
            'Te = Tc / (1 + Mex * Mex * (K2 - 1) / 2)
            End If
        Ve = Etanoz * Mex * Sqr(Te * Kve)                           'Effective exit velocity
        'Ve = Etanoz * Mex * Sqr(Te * Runiv / Mw * K2)
        
        F = Mnoz * Ve + (Pe - Patm) * Aexit: If F < 0 Then F = 0    'Delivered thrust
        Itsum = Itsum + F * dT                                      'Total impulse
        If F > Fmax Then Fmax = F: TFmax = T                        'Maximum thrust
        If Pc > Pmax Then Pmax = Pc: TPmax = T                      'Maximum pressure
        If R > Rmax Then Rmax = R                                   'Maximum burn rate
        If A > Amax Then Amax = A                                   'Maximum nozzle expansion ratio
        
        Loop
    
    BurnCurveN = N: BurnCurveT = dT: BurnCurveP = -1
    Tthr = T                                                        'End of thrust time
    If BurnCurveN <= 0 Or Tbout <= 0 Or Tthr <= 0 Or _
            Mg <= 0 Or Vg <= 0 Then
Ext:
        Erase BurnCurve: BurnCurveM = 0: BurnCurveN = 0: BurnCurveT = 0: BurnCurveP = -1
ExtMsg:
        Pic.Cls: PicH.Cls: PicV.Cls: PicD.Cls: Txt = ""
        PrintPic Pic, IIf(Msg <> "", Msg, "Burn simulation error"), _
            , , 4, 3, &H0&, &H4040FF, &HE0E0FF, iWarning
        GoTo NoSave
        End If
    'Xdmax = Xd                                                      'Total burn distance
    If Exprat >= 1 Then Aavg = Exprat: Amax = Exprat _
    Else Aavg = Aavg / Tthr: Exprat = Aavg: _
        Aexit = At * Exprat: Dexit = Sqr(Aexit / Pi * 4)            'Average nozzle expansion ratio
    Pavg = Pavg / Tthr                                              'Average pressure
    Favg = Itsum / Tthr                                             'Average thrust
    Isp = Itsum / G0 / Mg                                           'Specific impulse
    
    On Error GoTo 0
NoCalc:
    On Error Resume Next
    dT = BurnCurveT
    Q = IfInt(GrayColor(Pic.BackColor) >= 128, vbWhite, vbBlack)
    C1 = Q Xor &H404040
    
    'Adjust graph scale
    Pic.Cls: X = 4: Y = 0
    WW = Pic.TextWidth(" 0.00MM") + X: HH = Pic.TextHeight("")
    W = Pic.ScaleWidth - WW: H = Pic.ScaleHeight - HH - Int(HH / 2)
    Y = Y + H + Int(HH / 2): If W < 15 Or H < 15 Then GoTo NoPic
    SX2 = IfDbl(Units, Inch, 1)
    MX = IfDbl(IsAdjust And BurnStyle > 0, Max.Diameter / SX2, Tthr) * 1.05
    If MX <= 0 Then GoTo NoPic
    PX3 = 10 ^ Int(VBA.Log(MX) / Log10): PX = MX / PX3
         If PX >= 5 Then PX = PX3 * 0.5: PX2 = PX3 * 2.5: PX3 = PX3 * 2.5 _
    Else If PX >= 2 Then PX = PX3 * 0.2: PX2 = PX3 * 1: PX3 = PX3 * 1 _
                    Else PX = PX3 * 0.1: PX2 = PX3 * 0.5: PX3 = PX3 * 0.5
    SX = Int(W / MX * PX) / PX
    PPX = RoundInt(PX * SX): PPX2 = RoundInt(PX2 * SX): PPX3 = RoundInt(PX3 * SX)
    If SX <= 0 Or PPX < 1 Or PPX2 < 1 Or PPX3 < 1 Then GoTo NoPic
    I = 1
    If IsAdjust And BurnStyle > 0 Then
        Select Case BurnCurveD
        Case 0: MY = Max.Impulse * 1.05: If Units Then I = PoundForce   'Total impulse
        Case 1: MY = Max.Isp * 1.05                                     'Specific impulse
        Case 2: MY = Max.Thrust * 1.05: If Units Then I = PoundForce    'Max thrust
        Case 3: MY = Max.Pressure * 1.05: If AtmPressure Then I = Pascal _
                                  Else If Units Then I = Psi            'Max pressure
            End Select
    Else
        Select Case BurnCurveD
        Case 0: MY = Fmax * 1.05: If Units Then I = PoundForce          'Thrust
        Case 1: MY = Pmax * 1.05: If AtmPressure Then I = Pascal _
                                  Else If Units Then I = Psi            'Pressure
        Case 2: MY = Rmax * 1.05: If Units Then I = Inch                'Burn rate
        Case 3: MY = Amax * 1.05                                        'Nozzle expansion ratio
            End Select
        End If
    If MY <= 0 Then MY = 1
    MY = MY / I: PY3 = 10 ^ Int(VBA.Log(MY) / Log10): PY = MY / PY3
         If PY >= 5 Then PY = PY3 * 0.5: PY2 = PY3 * 2.5: PY3 = PY3 * 2.5 _
    Else If PY >= 2 Then PY = PY3 * 0.2: PY2 = PY3 * 1: PY3 = PY3 * 1 _
                    Else PY = PY3 * 0.1: PY2 = PY3 * 0.5: PY3 = PY3 * 0.5
    SY = Int(H / MY * PY) / PY: SY = SY / I: PY = PY * I: PY2 = PY2 * I: PY3 = PY3 * I
    PPY = RoundInt(PY * SY): PPY2 = RoundInt(PY2 * SY): PPY3 = RoundInt(PY3 * SY)
    If SY <= 0 Or PPY < 1 Or PPY2 < 1 Or PPY3 < 1 Then GoTo NoPic
    If Mode = BurnModeLog Then
        BurnCurveP = -1
    ElseIf Mode <= BurnModeCursor Then
        If IsAdjust And BurnStyle > 0 Then
            C = IfInt(BurnStyle = 1, BurnThroatN, BurnExitN)
            If Relative Then
                BurnCurveP = BurnCurveP + Pos
            Else
                If Pos < -1 Then BurnCurveP = -1: GoTo NoAdjust _
                Else If Pos < 0 Then BurnCurveP = C - 1 _
                Else If BurnStyle = 1 Then N = C: Do: N = N - 1: _
                    Loop While N > 0 And Pos < X + BurnThroat(N).Diameter / SX2 * SX: BurnCurveP = N _
                Else N = C: Do: N = N - 1: _
                    Loop While N > 0 And Pos < X + BurnExit(N).Diameter / SX2 * SX: BurnCurveP = N
                End If
            If BurnCurveP < 1 Then BurnCurveP = 1 _
            Else If BurnCurveP > C - 1 Then BurnCurveP = C - 1
        Else
            If Relative Then
                BurnCurveP = BurnCurveP + Pos
            Else
                If Pos < -1 Then BurnCurveP = -1: GoTo NoAdjust
                If Pos < 0 Then BurnCurveP = BurnCurveN - 1 _
                Else BurnCurveP = RoundInt((Pos - X) / SX / dT)
                End If
            If BurnCurveP < 0 Then BurnCurveP = 0 _
            Else If BurnCurveP > BurnCurveN - 1 Then BurnCurveP = BurnCurveN - 1
            End If
        End If
NoAdjust:
    If IsAdjust And BurnStyle > 0 Then GoTo NoBack
    
    'Max pressure
    J = False: C3 = Q Xor &HC1C2C
    For C = 0 To W - 1
        N = Int(C / SX / dT): If N >= BurnCurveN Then N = BurnCurveN - 1
        If BurnCurve(N).Pressure - Patm > Pbst Xor J Then J = Not J: _
            If J Then Pic.CurrentX = X + C: Pic.CurrentY = Y _
            Else Pic.Line -(X + C, Y - H), C3, BF
        If N >= BurnCurveN - 1 Then Exit For
        Next
    If J Then Pic.Line -(X + C, Y - H), C3, BF
    
    'Low nozzle exit pressure
    J = False: C3 = Q Xor &H303010
    For C = 0 To W - 1
        N = Int(C / SX / dT): If N >= BurnCurveN Then N = BurnCurveN - 1
        If BurnCurve(N).Thrust <= 0 Xor J Then J = Not J: _
            If J Then Pic.CurrentX = X + C: Pic.CurrentY = Y _
            Else Pic.Line -(X + C, Y - H), C3, BF
        If N >= BurnCurveN - 1 Then Exit For
        Next
    If J Then Pic.Line -(X + C, Y - H), C3, BF
NoBack:
    'Scale lines
    C2 = Q Xor &H808080: C3 = Q Xor &HC0C0C0
    For N = 0 To W Step PPX: Pic.Line (X + N, Y - H)-Step(0, H), C1: Next
    For N = 0 To H Step PPY: Pic.Line (X, Y - N)-Step(W, 0), C1: Next
    For N = 0 To W Step PPX2: Pic.Line (X + N, Y - H)-Step(0, H), C2: Next
    For N = 0 To H Step PPY2: Pic.Line (X, Y - N)-Step(W, 0), C2: Next
    For N = 0 To W Step PPX3
        Pic.CurrentX = X + N: Pic.CurrentY = Y: If Not IsAdjust Or BurnStyle = 0 Then _
            Pic.Print NumG(RoundN(N / SX)) & "s" Else If Units Then _
            Pic.Print NumD(RoundN(N / SX)) & "in" Else _
            Pic.Print NumE(N / SX) & "m"
        Next
    For N = 0 To H Step PPY3
        If N > 0 Then
            Pic.CurrentX = X + W: Pic.CurrentY = Y - N - Int(HH / 2)
            G = RoundN(N / SY / I)
            If IsAdjust And BurnStyle > 0 Then
                Select Case BurnCurveD
                Case 0: Pic.Print " " & NumE(G) & IIf(Units, "lbf", "N") 'Total impulse
                Case 1: Pic.Print " " & NumD(G) & "s"                    'Specific impulse
                Case 2: Pic.Print " " & NumE(G) & IIf(Units, "lbf", "N") 'Max thrust
                Case 3: If AtmPressure Then Pic.Print " " & NumD(G) & "atm" _
                        Else If Units Then Pic.Print " " & NumD(G) & "psi" _
                        Else Pic.Print " " & NumE(G) & "Pa"              'Max pressure
                    End Select
            Else
                Select Case BurnCurveD
                Case 0: Pic.Print " " & NumE(G) & IIf(Units, "lbf", "N") 'Thrust
                Case 1: If AtmPressure Then Pic.Print " " & NumD(G) & "atm" _
                        Else If Units Then Pic.Print " " & NumD(G) & "psi" _
                        Else Pic.Print " " & NumE(G) & "Pa"              'Pressure
                Case 2: If Units Then Pic.Print " " & NumD(G) & "in" _
                        Else Pic.Print " " & NumE(G) & "m"               'Burn rate
                Case 3: Pic.Print " " & NumD(G)                          'Nozzle expansion ratio
                    End Select
                End If
            End If
        Next
    Pic.Line (X, Y)-Step(0, -H), C3
    Pic.Line (X, Y)-Step(W, 0), C3
    
    'Reference lines
    C3 = Q Xor &HC0C0C0
    Pic.DrawStyle = vbDot
    If IsAdjust And BurnStyle > 0 Then
        Pic.Line (X + Dti / SX2 * SX, Y)-Step(0, -H), C3
        Pic.Line (X + Dexit / SX2 * SX, Y)-Step(0, -H), C3
        If BurnCurveD = 3 Then Pic.Line (X, Y - (Pbst + Patm) * SY)-Step(W, 0), Q Xor &HC0C020
    Else
        Select Case BurnCurveD
        Case 0: Pic.Line (X, Y - Favg * SY)-Step(W, 0), C3              'Thrust
                'Pic.Line (X, Y - Fmax * SY)-Step(W, 0), C3
        Case 1: Pic.Line (X, Y - Pavg * SY)-Step(W, 0), C3              'Pressure
                'Pic.Line (X, Y - Pmax * SY)-Step(W, 0), C3
                Pic.Line (X, Y - Patm * SY)-Step(W, 0), C3
                Pic.Line (X, Y - Pout * SY)-Step(W, 0), C3
                Pic.Line (X, Y - (Pbst + Patm) * SY)-Step(W, 0), Q Xor &HC0C020
        Case 2: Pic.Line (X, Y - Ravg * SY)-Step(W, 0), C3              'Burn rate
                'Pic.Line (X, Y - Rmax * SY)-Step(W, 0), C3
        Case 3: Pic.Line (X, Y - Aavg * SY)-Step(W, 0), C3              'Nozzle expansion ratio
                'Pic.Line (X, Y - Amax * SY)-Step(W, 0), C3
            End Select
        Pic.Line (X + TFmax * SX, Y)-Step(0, -H), C3
        Pic.Line (X + Tbout * SX, Y)-Step(0, -H), C3
        Pic.Line (X + Tthr * SX, Y)-Step(0, -H), C3
        End If
    Pic.DrawStyle = vbSolid
    
    'Data graph
    Pic.DrawWidth = 2
    If IsAdjust And BurnStyle > 0 Then
        For N = 1 To BurnThroatN - 1
            Select Case BurnCurveD
            Case 0: G = BurnThroat(N).Impulse:  C2 = cBurnThroatClass    'Total impulse
            Case 1: G = BurnThroat(N).Isp:      C2 = cBurnThroatIsp      'Specific impulse
            Case 2: G = BurnThroat(N).Thrust:   C2 = cBurnThroatThrust   'Max thrust
            Case 3: G = BurnThroat(N).Pressure: C2 = cBurnThroatPressure 'Max pressure
                End Select
            If N = 1 Then _
                Pic.CurrentX = X + BurnThroat(N).Diameter / SX2 * SX: Pic.CurrentY = Y - G * SY _
            Else Pic.Line -(X + BurnThroat(N).Diameter / SX2 * SX, Y - G * SY), C2
            Next
        For N = 1 To BurnExitN - 1
            Select Case BurnCurveD
            Case 0: G = BurnExit(N).Impulse:  C2 = cBurnExitClass        'Total impulse
            Case 1: G = BurnExit(N).Isp:      C2 = cBurnExitIsp          'Specific impulse
            Case 2: G = BurnExit(N).Thrust:   C2 = cBurnExitThrust       'Max thrust
            Case 3: G = BurnExit(N).Pressure: C2 = cBurnExitPressure     'Max pressure
                End Select
            If N = 1 Then _
                Pic.CurrentX = X + BurnExit(N).Diameter / SX2 * SX: Pic.CurrentY = Y - G * SY _
            Else Pic.Line -(X + BurnExit(N).Diameter / SX2 * SX, Y - G * SY), C2
            Next
    Else
        For C = 0 To W - 1
            N = Int(C / SX / dT): If N >= BurnCurveN Then N = BurnCurveN - 1
            Select Case BurnCurveD
            Case 0: G = BurnCurve(N).Thrust:   C2 = cBurnThrust          'Thrust
            Case 1: G = BurnCurve(N).Pressure: C2 = cBurnPressure        'Pressure
            Case 2: G = BurnCurve(N).BurnRate: C2 = cBurnRate            'Burn rate
            Case 3: G = BurnCurve(N).ExpRatio: C2 = cBurnRatio           'Nozzle expansion ratio
                End Select
            If C = 0 Then Pic.CurrentX = X: Pic.CurrentY = Y - G * SY _
            Else Pic.Line -(X + C, Y - G * SY), C2
            If N >= BurnCurveN - 1 Then Exit For
            Next
        End If
        
    'Cursor
    Pic.DrawWidth = 1
    I = (D0 - Di0) / 2 * BurnPreview
    If IsAdjust And BurnStyle > 0 Then
        If BurnCurveP < 1 Or BurnCurveP >= IfInt(BurnStyle = 1, BurnThroatN, BurnExitN) Then
            BurnCurveP = -1
        Else
            If BurnStyle = 1 Then _
                G = BurnThroat(BurnCurveP).Diameter Else G = BurnExit(BurnCurveP).Diameter
            Pic.Line (X + G / SX2 * SX, 0)-Step(0, Pic.ScaleHeight), Q Xor &H4080C0
            PrintPic Pic, " " & ToSize(G, FFive) & " ", Pic.CurrentX + 2, Pic.ScaleHeight, , _
                0, &H0&, &H4040C0, &HE0E0FF
            End If
    Else
        If BurnCurveP < 0 Or BurnCurveP >= BurnCurveN Then
            BurnCurveP = -1
        Else
            I = BurnCurve(BurnCurveP).Burn
            Pic.Line (X + BurnCurveP * dT * SX, 0)-Step(0, Pic.ScaleHeight), Q Xor &H4080C0
            PrintPic Pic, " " & ToSec(BurnCurveP * dT) & " ", Pic.CurrentX + 2, Pic.ScaleHeight, , _
                0, &H0&, &H4040C0, &HE0E0FF
            End If
        End If
    
    'Cross section
    PicH.Cls: PicV.Cls: C2 = &H808080: C3 = &HC0& ': PicH.DrawWidth = 3
    WW = PicH.ScaleWidth: HH = PicH.ScaleHeight: If WW < 15 Or HH < 15 Then GoTo NoModel
    W = Int((IfSng(WW < HH, WW, HH)) / 2) - 1: C0 = PicH.BackColor
    X = Int(WW / 2) - W: X = IfSng(X > 0, X, 0) + W
    Y = Int(HH / 2) - W: Y = IfSng(Y > 0, Y, 0) + W
    PicH.FillColor = C1: PicH.Circle (X, Y), W, IfInt(Md = 2, C0, C2)    'Chamber and propellant
    If Md <> 1 And Ld > 0 Then
        If IfDbl(Ei < 1, 0, I) >= IfDbl(Ei < 2, L0, L0 - I) Then Dp = W _
        Else Dp = W * (Di0 + I * 2) / D0: If Dp < 0 Then Dp = 0 Else If Dp > W Then Dp = W
        If Md = 2 Then
            PicH.FillColor = C0: PicH.Circle (X, Y), Dp, C0              'Burned core
            DrawFins PicH, Nf, Di0, D0, Fd0, Fw0, W, I, X, Y, C0, C0     'Burned fins
            PicH.FillStyle = vbFSTransparent
            DrawFins PicH, Nf, Di0, D0, Fd0, Fw0, W, , X, Y, C2          'Fin walls
            DrawFins PicH, Nf, Di0, D0, Fd0, Fw0, W, I, X, Y, C3         'Burned fin walls
            PicH.Circle (X, Y), W * Di0 / D0, C2                         'Core walls
            PicH.Circle (X, Y), W, C2                                    'Chamber walls
            PicH.FillStyle = vbFSSolid
        Else
            PicH.FillColor = C0: PicH.Circle (X, Y), Dp, C0              'Burned core
            PicH.Circle (X, Y), W * Di0 / D0, C2                         'Core
            PicH.FillStyle = vbFSTransparent
            PicH.Circle (X, Y), Dp, IfInt(Dp < W, C3, C2)                'Burned core walls
            PicH.FillStyle = vbFSSolid
            End If
    Else
        If IfDbl(Ei < 1, 0, I) >= IfDbl(Ei < 2, L0, L0 - I) Then Dp = W: _
            PicH.FillColor = C0: PicH.Circle (X, Y), Dp, C2              'Burned core
        End If
    
    'Longitudinal section
    WW = PicV.ScaleWidth - 1: HH = PicV.ScaleHeight: If WW < 15 Or HH < 15 Then GoTo NoModel
    H = W * 2: W = Int((H * D0 / Lc) / 2): X = Int(WW / 2): Y = H
    If W > Int(WW / 2) Then W = X: H = Int(W * Lc / D0 * 2)
    Y = Int((HH - H) / 2) + H: HH = H: H = H * Lg / Lc: C0 = PicV.BackColor
    PicV.FillColor = C0: PicV.Line (X - W, Y)-(X + W, Y - HH), C2, B     'Chamber
    Y = Y - (HH - H): C = IfInt(Ng > HH, HH, Ng): H = H / C
    For N = 0 To C - 1
        Dp = W * (Di0 + I * 2) / D0: If Dp < 0 Then Dp = 0 Else If Dp > W Then Dp = W
        If Md = 2 Then
            Dpf = Dp + Int(W * Fd0 * 2 / D0): If Dpf < 0 Then Dpf = 0 Else If Dpf > W Then Dpf = W
            Dp = DrawFins(, Nf, Di0, D0, Fd0, Fw0, W, I): If Dp < 0 Then Dp = 0 Else If Dp > W Then Dp = W
            End If
        If Ei < 2 Then Bp = H _
        Else Bp = H * (L0 - I) / L0: If Bp < 0 Then Bp = 0 Else If Bp > H Then Bp = H
        Cp = H * (Ld + I) / L0: If Cp < 0 Then Cp = 0 Else If Cp > H Then Cp = H
        If Ei < 1 Then Np = 0 _
        Else Np = H * I / L0: If Np < 0 Then Np = 0 Else If Np > H Then Np = H
        If Bp > Np Then PicV.FillColor = C1: _
            PicV.Line (X - W, Y - Np)-(X + W, Y - Bp), C1, B             'Burned propellant
        If Md <> 1 And Ld > 0 And Cp > Np And Bp > Np Then PicV.FillColor = C0: _
            PicV.Line (X - Dp, Y)-(X + Dp, Y - Cp), C0, B                'Burned core
        PicV.FillStyle = vbFSTransparent
        If Md = 2 Then Z = W * (Di0 + Fd0 * 2) / D0: If Z < W Then _
            PicV.Line (X + Z, Y)-(X + Z, Y - H * Ld / L0), C2 Or &H404040: _
            If Nf > 1 Then PicV.Line (X - Z, Y)-(X - Z, Y - H * Ld / L0), C2 Or &H404040 'Fin walls
        PicV.Line (X - W, Y)-(X + W, Y - H), C2, B                       'Propellant
        If Md <> 1 And Ld > 0 Then
            Z = W * Di0 / D0 ': If Md = 2 Then Z = DrawFins(, Nf, Di0, D0, Fd0, Fw0, W)
            PicV.Line (X - Z, Y)-(X + Z, Y - H * Ld / L0), C2, B 'Core
            If Bp > Np Then
                If Dp < W Then
                    If Bp < Cp Then Z = Bp Else Z = Cp
                    If Md = 2 And Dpf < W Then
                        PicV.Line (X + Dpf, Y - Np)-(X + Dpf, Y - Z - 1), C3 Or &H808080 'Burned fin walls
                        If Nf > 1 Then PicV.Line (X - Dpf, Y - Np)-(X - Dpf, Y - Z - 1), C3 Or &H808080
                        End If
                    PicV.Line (X - Dp, Y - Np)-(X - Dp, Y - Z - 1), C3   'Burned core walls
                    PicV.Line (X + Dp, Y - Np)-(X + Dp, Y - Z - 1), C3
                    If Ei >= 1 Then
                        PicV.Line (X - W, Y - Np)-(X - Dp, Y - Np), C3   'Burned nozzle end
                        PicV.Line (X + Dp, Y - Np)-(X + W, Y - Np), C3
                        End If
                Else
                    Z = Cp
                    End If
                If Cp < Bp Then
                    If Md = 2 Then _
                        PicV.Line (X - Dpf, Y - Z)-(X + Dpf, Y - Z), C3 Or &H808080 'Burned fin end
                    PicV.Line (X - Dp, Y - Z)-(X + Dp, Y - Z), C3        'Burned core end
                    If Ei >= 2 Then _
                        PicV.Line (X - W, Y - Bp)-(X + W, Y - Bp), C3    'Burned back end
                ElseIf Ei >= 2 Then
                    PicV.Line (X - W, Y - Bp)-(X - Dp, Y - Bp), C3       'Burned back end
                    PicV.Line (X + Dp, Y - Bp)-(X + W, Y - Bp), C3
                    End If
                End If
        ElseIf Bp > Np Then
            If Ei >= 2 Then _
                PicV.Line (X - W, Y - Bp)-(X + W, Y - Bp), C3            'Burned back end
            PicV.Line (X - W, Y - Np)-(X + W, Y - Np), C3                'Burned nozzle end
            End If
        PicV.FillStyle = vbFSSolid
        Y = Y - H
        Next
NoModel:
NoPic:
    'Graph data
    PicD.Cls: PicD.Print Tab(2);: N = PicD.ScaleWidth / PicD.CurrentX: PicD.CurrentX = 0

    If BurnCurveP < 0 Or BurnCurveP >= BurnCurveN Then
        C = N * 0.55: BurnCurveP = -1
        PicD.Print "Class"; Tab(C); ToClass(Itsum, , , "  "); ToForce(Itsum, FShort) & "s"
        PicD.Print "Isp"; Tab(C); NumX(Isp, FShort) & "s"
        PicD.Print "Max thrust"; Tab(C); ToForce(Fmax, FShort)
        PicD.Print "Max pressure"; Tab(C); ToPressureAtm(Pmax, FShort)
    ElseIf IsAdjust And BurnStyle > 0 Then
        C = N * 0.55: Q = PicD.ForeColor: N = PicD.TextWidth(" ")
        If BurnCurveD = 0 Then PicD.ForeColor = IfInt(BurnStyle = 1, cBurnThroatClass, cBurnExitClass): PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Impulse Else G = BurnExit(BurnCurveP).Impulse
            PicD.Print "Class"; Tab(C); ToClass(G, , , "  "); ToForce(G, FShort) & "s"
        If BurnCurveD = 1 Then PicD.ForeColor = IfInt(BurnStyle = 1, cBurnThroatIsp, cBurnExitIsp): PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Isp Else G = BurnExit(BurnCurveP).Isp
            PicD.Print "Isp"; Tab(C); NumX(G, FShort) & "s"
        If BurnCurveD = 2 Then PicD.ForeColor = IfInt(BurnStyle = 1, cBurnThroatThrust, cBurnExitThrust): PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Thrust Else G = BurnExit(BurnCurveP).Thrust
            PicD.Print "Max thrust"; Tab(C); ToForce(G, FShort)
        If BurnCurveD = 3 Then PicD.ForeColor = IfInt(BurnStyle = 1, cBurnThroatPressure, cBurnExitPressure): PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Pressure Else G = BurnExit(BurnCurveP).Pressure
            PicD.Print "Max pressure"; Tab(C); ToPressureAtm(G, FShort)
    Else
        C = N * 0.45: Q = PicD.ForeColor: N = PicD.TextWidth(" ")
        'PicD.CurrentX = N: PicD.Print "Time"; Tab(C); ToSec(BurnCurveP * dT)
        With BurnCurve(BurnCurveP)
        If BurnCurveD = 0 Then PicD.ForeColor = cBurnThrust: PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: PicD.Print "Thrust"; Tab(C); ToForce(.Thrust, FShort)
        If BurnCurveD = 1 Then PicD.ForeColor = cBurnPressure: PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: PicD.Print "Pressure"; Tab(C); ToPressureAtm(.Pressure, FShort)
        If BurnCurveD = 2 Then PicD.ForeColor = cBurnRate: PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: PicD.Print "Burn rate"; Tab(C); ToSize(.BurnRate, FShort, True) & "/s"
        If BurnCurveD = 3 Then PicD.ForeColor = cBurnRatio: PicD.Print "";: PicD.ForeColor = Q
            PicD.CurrentX = N: PicD.Print "Exp ratio"; Tab(C); NumX(.ExpRatio, FShort) & ":1"
        End With
        End If
NoData:
    'Engine specifications
    If Mode <= BurnModeLog Then GoTo NoLog
    UpdateLog "Class:  " & ToClass(Itsum, , , "  ") & ToForce(Itsum, FShort) & "s" & vbCrLf & _
        "Isp:  " & NumX(Isp, FShort) & "s" & vbCrLf & _
        "Avg thrust:  " & ToForce(Favg, FShort) & vbCrLf & _
        "Max thrust:  " & ToForce(Fmax, FShort) & vbCrLf & _
        "Max pressure:  " & ToPressureAtm(Pmax, FShort) & vbCrLf & _
        "Burst pressure:  " & IIf(Pbst < Infinite, ToPressureAtm(Pbst + Patm, FShort), "Unlimited") & vbCrLf & _
        "At burn time:  " & ToSec(TPmax) & vbCrLf & _
        "Burnout time:  " & ToSec(Tbout) & vbCrLf & _
        "Thrust time:  " & ToSec(Tthr) & vbCrLf & _
        "Avg burn rate:  " & ToSize(Ravg, FMini, True) & "/s" & vbCrLf & _
        "Geometry:  " & IIf(Md = 2 And Nf > 0, Nf & "-", "") & Gc & vbCrLf & _
        "Chamber:  " & ToSize(Lc, , True) & vbCrLf & _
        "Length:  " & IIf(Ng > 1, Ng & " x ", "") & ToSize(L0, , True) & vbCrLf & _
        "Diameter:  " & ToSize(D0, , True) & vbCrLf & _
        "Thickness:  " & ToSize(Tn, , True) & vbCrLf & _
        Switch(Md <> 1, "Core length:  " & ToSize(Ld, , True) & vbCrLf, True, "") & _
        Switch(Md <> 1, "Core diameter:  " & ToSize(Di0, , True) & vbCrLf, True, "") & _
        Switch(Md = 2, "Fin depth:  " & ToSize(Fd0, , True) & vbCrLf, True, "") & _
        Switch(Md = 2, "Fin width:  " & ToSize(Fw0, , True) & vbCrLf, True, "") & _
        "Throat:  " & ToSize(Dti, , True) & " (" & NumX(Kn, FMini) & ":1)" & vbCrLf & _
        "Exit:  " & ToSize(Dexit, , True) & " (" & NumX(Exprat, FMini) & ":1)" & vbCrLf & _
        "Volume:  " & ToVolume(Vg, FMini) & vbCrLf & _
        "Mass:  " & ToMass(Mg, FShort) & " (" & NumX(Vt * 100, FOne) & "%)" & vbCrLf & _
        "Dry mass:  " & ToMass(Mc, FShort) & " (" & NumX(Mc / Mt * 100, FOne) & "%)" & vbCrLf & _
        "Total mass:  " & ToMass(Mt, FShort)
NoLog:
    Pic.Refresh: PicH.Refresh: PicV.Refresh: PicD.Refresh
    On Error GoTo 0
    
    On Error Resume Next
    If Mode < BurnModeCurve Or Mode > BurnModeEngine Or _
        Tthr <= 0 Or Fmax <= 0 Or File = "" Then GoTo NoSave
    If Mode = BurnModeCurve Then _
         StrAdd "Curve 1 1 P 1 1 Generic" & vbCrLf _
    Else StrAdd File & " " & Int((Dc + Tn * 2) * 1000) & " " & Int(Lc * 1000) & " P " & _
            NumX(Mg, FShort) & " " & NumX(Mt, FShort) & _
            " Generic" & vbCrLf
    For N = 1 To 100
        C = RoundInt(N * (BurnCurveN - 1) / 100)
        X = C * dT: Y = BurnCurve(C).Thrust
        If Mode = BurnModeCurve Then X = X / Tthr: Y = Y / Fmax
        S = NumXS(Y, FShort): StrAdd "   " & NumXS(X, FShort) & " " & S & vbCrLf
        If Val(S) <= 0 Then Exit For
        Next
    Open EnginesDir & File & IIf(Mode = BurnModeCurve, ".cur", ".eng") For Output As 1
    If FreeFile > 1 Then Print #1, StrAdd;
    Close
    LoadCurves False, True: LoadEngines False, True
    On Error GoTo 0
NoSave:
    If Note.Visible And Not Force Then Message
    IsBusy = False
    
    End Sub

Private Sub CopyData()
    Dim G As Double, S As String
    If BurnCurveN <= 0 Then Exit Sub
    Clipboard.Clear
    If BurnCurveP < 0 Or BurnCurveP >= BurnCurveN Then
        S = "Class" & Tab1 & ToClass(Itsum, , , "  ") & ToForce(Itsum, FShort) & "s" & vbCrLf & _
            "Isp" & Tab1 & NumX(Isp, FShort) & "s" & vbCrLf & _
            "Max thrust" & Tab1 & ToForce(Fmax, FShort) & vbCrLf & _
            "Max pressure" & Tab1 & ToPressureAtm(Pmax, FShort) & vbCrLf
    ElseIf IsAdjust And BurnStyle > 0 Then
        If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Impulse Else G = BurnExit(BurnCurveP).Impulse
            S = "Class" & Tab1 & ToClass(G, , , "  ") & ToForce(G, FShort) & "s" & vbCrLf
        If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Isp Else G = BurnExit(BurnCurveP).Isp
        S = S & "Isp" & Tab1 & NumX(G, FShort) & "s" & vbCrLf
        If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Thrust Else G = BurnExit(BurnCurveP).Thrust
        S = S & "Max thrust" & Tab1 & ToForce(G, FShort) & vbCrLf
        If BurnStyle = 1 Then G = BurnThroat(BurnCurveP).Pressure Else G = BurnExit(BurnCurveP).Pressure
        S = S & "Max pressure" & Tab1 & ToPressureAtm(G, FShort) & vbCrLf
    Else
        With BurnCurve(BurnCurveP)
        S = "Time" & Tab1 & ToSec(BurnCurveP * BurnCurveT) & vbCrLf & _
            "Thrust" & Tab1 & ToForce(.Thrust, FShort) & vbCrLf & _
            "Pressure" & Tab1 & ToPressureAtm(.Pressure, FShort) & vbCrLf & _
            "Burn rate" & Tab1 & ToSize(.BurnRate, FShort, True) & "/s" & vbCrLf & _
            "Exp ratio" & Tab1 & NumX(.ExpRatio, FShort) & ":1" & vbCrLf
        End With
        End If
    Clipboard.SetText S & vbCrLf & Replace(Txt, ":  ", Tab1) & vbCrLf
    End Sub

Sub SaveGraph(Optional Name As String)
    Dim N As Long, S As String, P As Boolean, Q As Boolean
    Static Op As OpenFileName
    If Not IsAdjust Then If BurnCurveN <= 0 Then Exit Sub
    If Name = "" Then Name = GetSaveFile(Op, File & ".csv", FileCSV, "csv", EnginesDir)
    If Name = "" Then Exit Sub
    On Error Resume Next
    Open Name For Output As 1: If FreeFile = 1 Then Exit Sub
    S = "#, Time[s], Thrust[N], Pressure[Pa], BurnRate[m/s], NozzleExpansionRatio"
    If LogOption And LogSeparator Then Print #1, Replace(S, ",", ";") Else Print #1, S
    For N = 0 To BurnCurveN - 1: With BurnCurve(N)
        S = N & "," & NumD(N * BurnCurveT) & "," & _
            NumD(.Thrust) & "," & NumD(.Pressure) & "," & NumD(.BurnRate) & "," & NumD(.ExpRatio)
        If LogOption And LogSeparator Then Print #1, ToSSV(S) Else Print #1, S
        End With: Next
    Close
    If IsAdjust Then
        SaveGraphEx "Throat", Name, BurnThroat, BurnThroatN
        SaveGraphEx "Exit", Name, BurnExit, BurnExitN
        End If
    On Error GoTo 0
    End Sub

Private Sub SaveGraphEx(Class As String, Name As String, A() As BurnPointB, ByVal N As Long)
    Dim C As Long, S As String
    If N <= 1 Then Exit Sub
    On Error Resume Next
    Open FileAddName(Name, "." & Class) For Output As 1: If FreeFile = 1 Then Exit Sub
    S = "#, " & Class & "Diameter[m], TotalImpulse[Ns], Isp[s], MaxThrust[C], MaxPressure[Pa]"
    If LogOption And LogSeparator Then Print #1, Replace(S, ",", ";") Else Print #1, S
    For C = 1 To N - 1: With A(C)
        S = C - 1 & "," & NumD(.Diameter) & "," & _
            NumD(.Impulse) & "," & NumD(.Isp) & "," & NumD(.Thrust) & "," & NumD(.Pressure)
        If LogOption And LogSeparator Then Print #1, ToSSV(S) Else Print #1, S
        End With: Next
    On Error GoTo 0
    Close
    End Sub

Sub UpdateMaterials()
    Dim A As Long, N As Long, S As String, T As String, U As String, _
        R As Double, D As Double
    T = LoadFile(EnginesDir & "Materials.lst")
    If T = "" Then T = _
        "Aluminum,70,2.7" & vbCrLf & _
        "Nickel,180,8.9" & vbCrLf & _
        "Aluminum alloy,400,2.7" & vbCrLf & _
        "Steel,600,7.8" & vbCrLf & _
        "Stainless steel,800,7.8" & vbCrLf & _
        "Titanium alloy,1000,4.5" & vbCrLf & _
        "Glass fiber,1200,2.5" & vbCrLf & _
        "Carbon fiber,1500,1.5" & vbCrLf
    A = 1: Do
        S = GetLine(T, A): If S = "" Then Exit Do
        If Left(S, 1) <> ";" Then
            U = Param(S): R = NumN(S): D = NumN(S)
            U = U & Tab1 & ToStressDensity(R, D)
            If N > mnBurst.UBound Then Load mnBurst(N)
            If mnBurst(N).Caption <> U Then mnBurst(N).Caption = U
            N = N + 1
            End If
        Loop
    For N = mnBurst.UBound To N Step -1
        If N > 0 Then Unload mnBurst(N) _
        Else mnBurst(0).Caption = "Steel" & Tab1 & ToStressDensity(600, 7.8)
        Next
    End Sub

Sub ShowBurstMenu()
    If mnBurst.UBound = 0 Then UpdateMaterials
    ShowMenu Me, mnStress, Pressure
    End Sub

Sub ShowPresetMenu()
    Dim N As Long, S As String
    LoadList EnginesDir, "*.ini"
    With mnPreset(0): .Visible = ListDelete("default"): .Checked = LCase(File) = "default": End With
    For N = 1 To List.Count
        S = List(N): If N > mnPreset.UBound Then Load mnPreset(N)
        With mnPreset(N): If .Caption <> S Then .Caption = S
        .Visible = True: .Checked = File = S: End With
        Next
    For N = mnPreset.UBound To List.Count + 1 Step -1: Unload mnPreset(N): Next
    mnSP1.Visible = mnPreset(0).Visible
    Check mnCalcCurve, BurnCalc = BurnModeCurve
    Check mnCalcEngine, BurnCalc = BurnModeEngine
    Check mnGraphLow, BurnDef = 0.001
    Check mnGraphMed, BurnDef = 0.0001
    Check mnGraphHigh, BurnDef = 0.00001
    ShowMenu Me, mnMenu, File, True, False
    End Sub

Sub ShowBurnMenu()
    Dim N As Long, Q As Boolean
    Q = Not IsAdjust Or BurnStyle = 0
        N = 0: Check mnData(N), BurnCurveD = N: mnData(N).Caption = IIf(Q, "Thrust", "Class")
    N = N + 1: Check mnData(N), BurnCurveD = N: mnData(N).Caption = IIf(Q, "Pressure", "Isp")
    N = N + 1: Check mnData(N), BurnCurveD = N: mnData(N).Caption = IIf(Q, "Burn rate", "Max thrust")
    N = N + 1: Check mnData(N), BurnCurveD = N: mnData(N).Caption = IIf(Q, "Expansion ratio", "Max pressure")
    Check mnBurnGraph, BurnStyle = 0
    Check mnThroatGraph, BurnStyle = 1
    Check mnExitGraph, BurnStyle = 2
    Check mnBurnPreview, BurnPreview > 0
    ShowMenu Me, mnOptions
    End Sub
