VERSION 5.00
Begin VB.Form Calc 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Trajectory editor"
   ClientHeight    =   2145
   ClientLeft      =   180
   ClientTop       =   450
   ClientWidth     =   1845
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Calc.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   143
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   123
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   Begin Project.Button Calc 
      Height          =   255
      Left            =   450
      TabIndex        =   6
      Top             =   1860
      Width           =   900
      _ExtentX        =   1588
      _ExtentY        =   450
      Caption         =   "Calculate"
      ToolTip         =   "Calculate trajectory"
   End
   Begin Project.Edit Descent 
      Height          =   225
      Left            =   75
      TabIndex        =   5
      Top             =   1575
      Width           =   1725
      _ExtentX        =   3043
      _ExtentY        =   397
      Caption         =   "Descent"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Parachute terminal velocity [m/s], [kn], [mph], [kph] (Free fall=70m/s, Balloon=25m/s, Default=5m/s)"
   End
   Begin Project.Edit Ascent 
      Height          =   225
      Left            =   75
      TabIndex        =   4
      Top             =   1275
      Width           =   1725
      _ExtentX        =   3043
      _ExtentY        =   397
      Caption         =   "Ascent"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Balloon ascent rate [m/s], [kn], [mph], [kph] or free lift [kg], [lb] (Default=5m/s)"
   End
   Begin Project.Edit Burst 
      Height          =   225
      Left            =   75
      TabIndex        =   3
      Top             =   975
      Width           =   1725
      _ExtentX        =   3043
      _ExtentY        =   397
      Caption         =   "Burst"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Balloon burst altitude [m], [ft] (Default=32km)"
   End
   Begin Project.Edit Orbit 
      Height          =   225
      Left            =   75
      TabIndex        =   2
      Top             =   675
      Width           =   1725
      _ExtentX        =   3043
      _ExtentY        =   397
      Caption         =   "Orbit"
      Numeric         =   -1  'True
      Alignment       =   1
      ToolTip         =   "Orbital altitude [m], [ft] or orbital period [s], [m], [h], [d] (Default=150km)"
   End
   Begin Project.DropList Mission 
      Height          =   225
      Left            =   75
      TabIndex        =   1
      Top             =   375
      Width           =   1725
      _ExtentX        =   3043
      _ExtentY        =   397
      Caption         =   "Mission"
      Numeric         =   -1  'True
      Alignment       =   1
      Style           =   2
      ToolTip         =   "Stimated mission time [s], [m], [h], [d], [y] (Default=2.5d)"
   End
   Begin Project.DropList Mode 
      Height          =   225
      Left            =   75
      TabIndex        =   0
      Top             =   75
      Width           =   1725
      _ExtentX        =   3704
      _ExtentY        =   397
      Caption         =   ""
      Text            =   "Balloon trajectory"
      List            =   "Balloon trajectory|Low Earth orbit|Medium Earth orbit|Moon mission"
      ToolTip         =   "Type of trajectory calculation"
      Locked          =   -1  'True
   End
End
Attribute VB_Name = "Calc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim NoResize As Boolean

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = vbFormControlMenu Then Cancel = True: Activate: Exit Sub
    End Sub

Sub Activate()
    If Main.WindowState = vbMinimized Then Exit Sub
    If Visible Then Hide Else Show vbModeless, Main
    If Options.SnapPanels Then ResizeMain
    End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
    Case vbKeyF1 To vbKeyF12, vbKeyEscape: Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case vbKeyC, vbKeyH, vbKeyV, vbKeyX, vbKeyZ
    Case vbKey0 To vbKey9, vbKeyA To vbKeyZ, vbKeySpace, vbKeyTab
        If Shift > 1 Then Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case vbKeyReturn: If Shift = 0 Then Calc_Click _
        Else Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case Else: If Shift > 4 Then Main.Form_KeyDown KeyCode, Shift And Not 4: KeyCode = 0
        End Select
    End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    Main.Form_KeyUp KeyCode, Shift
    End Sub

Sub Form_Resize()
    If NoResize Or IsInit Then Exit Sub
    NoResize = True: Move Left, Top, _
        (Round((ScaleWidth - 3) / CalcWidth) * CalcWidth + 3 - ScaleWidth) * TwipX + Width, _
        (Round((ScaleHeight - 3) / CalcHeight) * CalcHeight + 3 - ScaleHeight) * TwipY + Height: _
    ResizeCalc: NoResize = False: If Options.SnapPanels Then ResizeMain
    End Sub

Sub SetMode(Optional ByVal Value As Long, Optional ByVal Show As Boolean)
    If Value < 0 Then Value = 0
    If Mode.SelectedItem <> Value Then Mode.SelectItem Value
    If Show Then If Not Visible Then Activate
    End Sub

Private Sub Mode_Click(Item As Integer)
    SetMode Item
    End Sub

Private Sub Calc_Click()
    If Play <> Paused Then Exit Sub
    If Note.Active Then Note.Active = False: Exit Sub
    Select Case Mode.SelectedItem
    Case 1: CalcLEO
    Case 2: CalcMEO
    Case 3: CalcMoon
    Case Else: CalcBalloon
    End Select
    End Sub

'Private Sub Mission_MouseDown(Button As Integer, Shift As Integer)
'    Mission.SetFocus
'    End Sub

Private Sub Mission_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim S As String, N As Double
    If Button <> 1 Then Exit Sub
    S = Mission: If S = "" Then S = "2.5d"
    N = Val(S) - Y / Switch(Shift And 1, 1000, Shift And 2, 100, True, 10)
    If InStr(S, "y") Then S = "y" Else If InStr(S, "d") Then S = "d" _
    Else If InStr(S, "h") Then S = "h" Else If InStr(S, "m") Then S = "m" Else S = "s"
    Mission = NumX(N, Switch(Shift And 1, FShort, Shift And 2, FMini, True, FOne)) & S
    End Sub

Private Sub Mission_Change()
    If Mission <> "" Then GhostTime = ValTime(Mission) Else GhostTime = Day * 2.5
    If Play = Paused Then Render
    End Sub

Private Sub Mission_Up()
    If Shift <= 1 Then _
        Mission_MouseMove 1, 0, 0, -1
    End Sub

Private Sub Mission_Down()
    If Shift > 1 Then Orbit.SetFocus _
    Else Mission_MouseMove 1, 0, 0, 1
    End Sub

Private Sub Orbit_Up()
    If Shift > 1 Then Mission.SetFocus _
    Else EditUp Orbit
    End Sub

Private Sub Orbit_Down()
    If Shift > 1 Then Burst.SetFocus _
    Else EditDown Orbit
    End Sub

Private Sub Burst_Up()
    If Shift > 1 Then Orbit.SetFocus _
    Else If EditUp(Burst) Then If Mode.SelectedItem <= 0 Then Calc_Click
    End Sub

Private Sub Burst_Down()
    If Shift > 1 Then Ascent.SetFocus _
    Else If EditDown(Burst) Then If Mode.SelectedItem <= 0 Then Calc_Click
    End Sub

Private Sub Ascent_Up()
    If Shift > 1 Then Burst.SetFocus _
    Else If EditUp(Ascent) Then If Mode.SelectedItem <= 0 Then Calc_Click
    End Sub

Private Sub Ascent_Down()
    If Shift > 1 Then Descent.SetFocus _
    Else If EditDown(Ascent) Then If Mode.SelectedItem <= 0 Then Calc_Click
    End Sub

Private Sub Descent_Up()
    If Shift > 1 Then Ascent.SetFocus _
    Else If EditUp(Descent) Then If Mode.SelectedItem <= 0 Then Calc_Click
    End Sub

Private Sub Descent_Down()
    If Shift <= 1 Then _
        If EditDown(Descent) Then If Mode.SelectedItem <= 0 Then Calc_Click
    End Sub

