VERSION 5.00
Begin VB.UserControl Download 
   ClientHeight    =   240
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   240
   InvisibleAtRuntime=   -1  'True
   Picture         =   "Download.ctx":0000
   ScaleHeight     =   240
   ScaleWidth      =   240
   ToolboxBitmap   =   "Download.ctx":058A
End
Attribute VB_Name = "Download"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateDirectory Lib "Kernel32" Alias "CreateDirectoryA" (ByVal PathName As String, Optional ByVal SecurityAttributes As Long) As Long
Private Declare Function GetFileAttributes Lib "Kernel32" Alias "GetFileAttributesA" (ByVal FileName As String) As Long
Private Declare Function MoveFileEx Lib "Kernel32" Alias "MoveFileExA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal dwFlags As Long) As Long

Event DownloadProgress(SaveFile As String, CurBytes As Long, MaxBytes As Long)
Event DownloadComplete(SaveFile As String, MaxBytes As Long)
Event DownloadError(SaveFile As String)

Public BytesRead As Long, BytesMax As Long, IsBusy As Boolean, IsError As Boolean

Private Sub MkPath(Path As String)
    Dim N As Long
    Do: N = InStrRev(Path, "\", N - 1): If N = 0 Then Exit Do
        If GetFileAttributes(Left(Path, N - 1)) <> -1 Then Exit Do
        Loop
    Do: N = InStr(N + 1, Path, "\"): If N = 0 Then Exit Do
        If CreateDirectory(Left(Path, N - 1)) = 0 Then Exit Sub
        Loop
    End Sub

Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
    Dim File As Long, Data() As Byte
    On Error Resume Next
    If AsyncProp.StatusCode <> vbAsyncStatusCodeError Then
        MkPath AsyncProp.PropertyName
        If AsyncProp.AsyncType = vbAsyncTypeFile Then
            'If GetFileAttributes(AsyncProp.PropertyName) <> -1 Then Kill AsyncProp.PropertyName
            'Name AsyncProp.Value As AsyncProp.PropertyName
            MoveFileEx AsyncProp.Value, AsyncProp.PropertyName, &HB& 'MOVEFILE_REPLACE_EXISTING=1 MOVEFILE_COPY_ALLOWED=2 MOVEFILE_WRITE_THROUGH=8
        Else
            Data = AsyncProp.Value: File = FreeFile
            Open AsyncProp.PropertyName For Binary Access Write As File
            Put File, , Data
            Close File
            End If
        IsBusy = False
        RaiseEvent DownloadComplete(AsyncProp.PropertyName, CLng(AsyncProp.BytesMax))
    Else
Ext:
        IsBusy = False: IsError = True
        RaiseEvent DownloadError(AsyncProp.PropertyName)
        End If
    End Sub

Private Sub UserControl_AsyncReadProgress(AsyncProp As AsyncProperty)
    On Error Resume Next
    If AsyncProp.BytesMax Then
        BytesRead = AsyncProp.BytesRead: BytesMax = AsyncProp.BytesMax
        RaiseEvent DownloadProgress(AsyncProp.PropertyName, _
            CLng(AsyncProp.BytesRead), CLng(AsyncProp.BytesMax))
        End If
    DoEvents
    End Sub

Function Begin(URL As String, Optional SaveFile As String, _
        Optional ByVal Async As Boolean, Optional ByVal UseFile As Boolean) As Boolean
    On Error GoTo BeginError
    BytesMax = -1: BytesRead = 0
    If UseFile Then If SaveFile = "" Then SaveFile = Mid(URL, InStrRev(URL, "/") + 1)
    AsyncRead URL, IIf(UseFile, vbAsyncTypeFile, vbAsyncTypeByteArray), _
        SaveFile, vbAsyncReadForceUpdate Or IIf(Async, 0, vbAsyncReadSynchronousDownload)
    IsBusy = True: IsError = False: Begin = True
    Exit Function
BeginError:
    IsBusy = False: IsError = True
    RaiseEvent DownloadError(SaveFile)
    End Function

Sub Cancel(SaveFile As String)
    On Error Resume Next
    CancelAsyncRead SaveFile
    End Sub
