VERSION 5.00
Begin VB.Form Graph 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Graph"
   ClientHeight    =   2070
   ClientLeft      =   180
   ClientTop       =   450
   ClientWidth     =   6675
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Graph.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   138
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   445
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   Begin VB.PictureBox Pic 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   2070
      Left            =   0
      ScaleHeight     =   138
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   445
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   6675
   End
   Begin VB.Menu mnMenu 
      Caption         =   "Menu"
      Visible         =   0   'False
      Begin VB.Menu mnSimulation 
         Caption         =   "Simulation"
         Begin VB.Menu mnViewThrust 
            Caption         =   "Thrust"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnViewAccel 
            Caption         =   "Acceleration"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnViewDrag 
            Caption         =   "Air drag"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnViewTemp 
            Caption         =   "Temperature"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnViewLinks 
            Caption         =   "Radio links"
            Checked         =   -1  'True
         End
      End
      Begin VB.Menu mnBalloon 
         Caption         =   "Balloon"
         Begin VB.Menu mnViewAltitude 
            Caption         =   "Altitude"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnViewHSpeed 
            Caption         =   "Horizontal speed"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnViewATemp 
            Caption         =   "Temperature"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnViewHumidity 
            Caption         =   "Relative humidity"
            Checked         =   -1  'True
         End
      End
      Begin VB.Menu mnTimeScale 
         Caption         =   "Time scale"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnTimeLabels 
         Caption         =   "Time labels"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnDataScale 
         Caption         =   "Data scale"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnDataLabels 
         Caption         =   "Data labels"
      End
      Begin VB.Menu mnSS2 
         Caption         =   "-"
      End
      Begin VB.Menu mnScaleUp 
         Caption         =   "Scale up"
      End
      Begin VB.Menu mnScaleDown 
         Caption         =   "Scale down"
      End
      Begin VB.Menu mnSS3 
         Caption         =   "-"
      End
      Begin VB.Menu mnCopyImage 
         Caption         =   "Copy image"
      End
      Begin VB.Menu mnCopyData 
         Caption         =   "Copy data"
      End
      Begin VB.Menu mnSaveData 
         Caption         =   "Save data "
      End
      Begin VB.Menu mnSS4 
         Caption         =   "-"
      End
      Begin VB.Menu mnHide 
         Caption         =   "Hide"
      End
   End
End
Attribute VB_Name = "Graph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    If Not IsDebug Then SetGraphProc hWnd
    End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = vbFormControlMenu Then Cancel = True: Activate: Exit Sub
    If Not IsDebug Then SetGraphProc hWnd, False
    End Sub

Sub Activate()
    If Main.WindowState = vbMinimized Then Exit Sub
    If Visible Then Hide Else Show vbModeless, Main: Plot , 1
    If Options.SnapPanels Then ResizeMain
    End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If Tip.Visible Then Tip.Update
    Select Case KeyCode
    Case 1: If T >= GraphicMax Or Play = Paused Then Plot IfInt(Shift, -Hour, -Min), -5: Pic.Refresh
    Case 2: If T >= GraphicMax Or Play = Paused Then Plot IfInt(Shift, Hour, Min), -5: Pic.Refresh
    Case vbKeyUp, vbKeyAdd: mnScaleUp_Click
    Case vbKeyDown, vbKeySubtract: mnScaleDown_Click
    Case vbKeyMultiply: GraphicScale = 1: Plot: Pic.Refresh
    Case vbKeyLeft: If T >= GraphicMax Or Play = Paused Then Plot IfInt(Shift, -Min, -1): Pic.Refresh
    Case vbKeyRight: If T >= GraphicMax Or Play = Paused Then Plot IfInt(Shift, Min, 1): Pic.Refresh
    Case vbKeyPageUp: If T >= GraphicMax Or Play = Paused Then Plot IfInt(Shift, -Hour, -Min): Pic.Refresh
    Case vbKeyPageDown: If T >= GraphicMax Or Play = Paused Then Plot IfInt(Shift, Hour, Min): Pic.Refresh
    Case vbKeyHome: If T >= GraphicMax Or Play = Paused Then Plot , True: Pic.Refresh
    Case vbKeyEnd: If T >= GraphicMax Or Play = Paused Then Plot InfiniteInt \ 2: Pic.Refresh
    Case vbKeyContextMenu: ShowGraphMenu
    Case vbKeyInsert, vbKeyC: If Shift = 2 Then CopyGraph
    Case vbKeyF1 To vbKeyF12, vbKeyEscape: Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case vbKey0 To vbKey9, vbKeyA To vbKeyZ, vbKeySpace, vbKeyTab
        If Shift > 1 Then Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case vbKeyReturn
        If Shift Or IsTest Then Main.Form_KeyDown KeyCode, Shift: KeyCode = 0
    Case Else: If Shift > 4 Then Main.Form_KeyDown KeyCode, Shift And Not 4: KeyCode = 0
        End Select
    End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode: Case vbKeySnapshot: Main.Form_KeyUp KeyCode, Shift: End Select
    End Sub

Private Sub Form_Resize()
    Pic.Move 0, 0, ScaleWidth, ScaleHeight: If Visible Then Plot , 1
    If Options.SnapPanels Then ResizeMain
    End Sub

Private Sub mnViewThrust_Click()
    GraphicMode = GraphicMode Xor &H80&: Plot , 1
    End Sub

Private Sub mnViewAccel_Click()
    GraphicMode = GraphicMode Xor &H100&: Plot , 1
    End Sub

Private Sub mnViewDrag_Click()
    GraphicMode = GraphicMode Xor &H200&: Plot , 1
    End Sub

Private Sub mnViewTemp_Click()
    GraphicMode = GraphicMode Xor &H400&: Plot , 1
    End Sub

Private Sub mnPanelsLinks_Click()
    GraphicMode = GraphicMode Xor &H800&: Plot , 1
    End Sub

Private Sub mnViewAltitude_Click()
    GraphicMode = GraphicMode Xor &H1000&: Plot , 1
    End Sub

Private Sub mnViewHSpeed_Click()
    GraphicMode = GraphicMode Xor &H2000&: Plot , 1
    End Sub

Private Sub mnViewATemp_Click()
    GraphicMode = GraphicMode Xor &H20000: Plot , 1
    End Sub

Private Sub mnViewHumidity_Click()
    GraphicMode = GraphicMode Xor &H40000: Plot , 1
    End Sub

Private Sub mnTimeScale_Click()
    GraphicMode = GraphicMode Xor 1: Plot , 1
    End Sub

Private Sub mnTimeLabels_Click()
    GraphicMode = GraphicMode Xor 4: Plot , 1
    End Sub

Private Sub mnDataScale_Click()
    GraphicMode = GraphicMode Xor 2: Plot , 1
    End Sub

Private Sub mnDataLabels_Click()
    GraphicMode = GraphicMode Xor 8: Plot , 1
    End Sub

Private Sub mnScaleUp_Click()
    GraphicScale = GraphicScale * 10: Plot , 1
    End Sub

Private Sub mnScaleDown_Click()
    GraphicScale = GraphicScale / 10: Plot , 1
    End Sub

Private Sub mnCopyImage_Click()
    CopyImage Pic
    End Sub

Private Sub mnCopyData_Click()
    CopyGraph
    End Sub

Private Sub mnSaveData_Click()
    SaveGraph
    End Sub

Private Sub mnHide_Click()
    Activate
    End Sub

Private Sub Pic_DblClick()
    Plot , -4, MouseX, MouseY
    End Sub

Private Sub Pic_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Tip.Visible Then Tip.Update
    Select Case Button
    Case 1: Plot , -3, X, Y
        End Select
    End Sub

Private Sub Pic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case Button
    Case 0
        ToolTipGraph X, Y: If Shift = 0 Then _
            If T >= GraphicMax Or Play = Paused Then Plot , -2, X: Pic.Refresh
    Case 1
        If KMLPathN > 0 And T = 0 Then If KMLPath(0).Time <> 0 Then GoTo Nxt
        If T >= GraphicMax Or Play = Paused Then _
            GraphicWin = GraphicWin - X + MouseX: Plot , 1: Pic.Refresh
        GoTo Ext
Nxt:
        KMLPathWin = KMLPathWin - X + MouseX: Plot , 1: Pic.Refresh
Ext:
        End Select
    MouseX = X: MouseY = Y
    End Sub

Private Sub Pic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case Button
    Case 2: ShowGraphMenu
        End Select
    End Sub

Sub ShowGraphMenu()
    Check mnViewThrust, GraphicMode And &H80&
    Check mnViewAccel, GraphicMode And &H100&
    Check mnViewDrag, GraphicMode And &H200&
    Check mnViewTemp, GraphicMode And &H400&
    Check mnViewLinks, GraphicMode And &H800&
    Check mnViewAltitude, GraphicMode And &H1000&
    Check mnViewHSpeed, GraphicMode And &H2000&
    Check mnViewATemp, GraphicMode And &H20000
    Check mnViewHumidity, GraphicMode And &H40000
    Check mnTimeScale, GraphicMode And 1
    Check mnTimeLabels, GraphicMode And 4
    Check mnDataScale, GraphicMode And 2
    Check mnDataLabels, GraphicMode And 8
    PopupMenu mnMenu
    End Sub
